function createElement(e) {
  return document.createElementNS("http://www.w3.org/2000/svg", e);
}
function convertNamedNodeMapToObject(e) {
  const t = {};
  for (const n of Object.keys(e))
    t[e[n].name] = e[n];
  return t;
}
class SVGInstance {
  constructor(t, n) {
    this.childInstances = [], this.element = createElement(t), this._parent = n;
  }
  get parent() {
    return this._parent;
  }
  get root() {
    let t = this._parent;
    for (; (t == null ? void 0 : t.parent) !== void 0; )
      t = t.parent;
    return t;
  }
  appendInstance(t) {
    return this.childInstances.push(t), this.element.appendChild(t.element), this;
  }
  id(t) {
    return typeof t == "string" ? (this.element.id = t, this) : this.element.id;
  }
  get innerHTML() {
    return this.element.innerHTML;
  }
  get outerHTML() {
    return this.element.outerHTML;
  }
  empty() {
    return this.childInstances = [], this.element.innerHTML = "", this;
  }
  addClass(t) {
    return typeof t == "string" ? this.element.classList.add(t) : Array.isArray(t) && this.element.classList.add(...t), this;
  }
  removeClass(t) {
    return typeof t == "string" ? this.element.classList.remove(t) : Array.isArray(t) && this.element.classList.remove(...t), this;
  }
  hasClass(t) {
    return this.element.classList.contains(t);
  }
  attr(t, n) {
    var r;
    const a = Object.entries(convertNamedNodeMapToObject(this.element.attributes)).reduce((c, [d, u]) => Object.assign(Object.assign({}, c), { [d]: isNaN(+u.value) ? u.value : +u.value }), {});
    return typeof t == "undefined" ? a : typeof t == "object" ? Array.isArray(t) ? Object.fromEntries(Object.entries(a).filter(([c, d]) => t.includes(c))) : (Object.keys(t).forEach((c) => {
      this.element.setAttribute(c, t[c] + "");
    }), this) : typeof t == "string" ? typeof n == "undefined" ? (r = a[t]) !== null && r !== void 0 ? r : null : (this.element.setAttribute(t, n + ""), this) : null;
  }
  removeAttr(t) {
    return this.element.removeAttribute(t), this;
  }
}
function applyMixins(e, t) {
  t.forEach((n) => {
    Object.getOwnPropertyNames(n.prototype).forEach((r) => {
      Object.defineProperty(e.prototype, r, Object.getOwnPropertyDescriptor(n.prototype, r) || /* @__PURE__ */ Object.create(null));
    });
  });
}
class Color extends SVGInstance {
  color(t) {
    if (typeof t == "undefined") {
      const n = this.attr("color");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("color", t), this;
    return null;
  }
}
class Display extends SVGInstance {
  display(t) {
    if (typeof t == "undefined") {
      const n = this.attr("display");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("display", t), this;
    return null;
  }
}
class Fill extends SVGInstance {
  fill(t) {
    if (typeof t == "undefined") {
      const n = this.attr("fill");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("fill", t), this;
    return null;
  }
  fillOpacity(t) {
    if (typeof t == "undefined") {
      const n = this.attr("fill-opacity");
      return typeof n == "number" ? n : null;
    } else if (typeof t == "number")
      return this.attr("fill-opacity", t), this;
    return null;
  }
  fillRule(t) {
    if (typeof t == "undefined") {
      const n = this.attr("fill-rule");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("fill-rule", t), this;
    return null;
  }
  fillLinearGradient(t, n) {
    var r, a, c;
    const d = (a = (r = this.root) === null || r === void 0 ? void 0 : r.childInstances.find((o) => o.element.tagName === "defs")) !== null && a !== void 0 ? a : (c = this.root) === null || c === void 0 ? void 0 : c.addDefs(), u = d == null ? void 0 : d.addLinearGradient(), i = d.element.childNodes.length;
    u.attr("id", "gradient-" + i), typeof n == "number" && u.attr("gradientTransform", "rotate(" + n + ")");
    for (const o of t)
      u.addStop(o.position, o.color);
    return this.attr("fill", "url(#gradient-" + i + ")"), this;
  }
}
class Opacity extends SVGInstance {
  opacity(t) {
    if (typeof t == "undefined") {
      const n = this.attr("opacity");
      return typeof n == "number" ? n : null;
    } else if (typeof t == "number")
      return this.attr("opacity", t), this;
    return null;
  }
}
class Stroke extends SVGInstance {
  stroke(t = 1, n = "solid", r = "currentColor") {
    return this.strokeWidth(t), this.strokeColor(r), n === "dashed" && this.strokeDasharray(3), this;
  }
  strokeColor(t) {
    if (typeof t == "undefined") {
      const n = this.attr("stroke");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("stroke", t), this;
    return null;
  }
  strokeLinearGradient(t, n) {
    var r, a, c;
    const d = (a = (r = this.root) === null || r === void 0 ? void 0 : r.childInstances.find((o) => o.element.tagName === "defs")) !== null && a !== void 0 ? a : (c = this.root) === null || c === void 0 ? void 0 : c.addDefs(), u = d == null ? void 0 : d.addLinearGradient(), i = d.element.childNodes.length;
    u.attr("id", "gradient-" + i), typeof n == "number" && u.attr("gradientTransform", "rotate(" + n + ")");
    for (const o of t)
      u.addStop(o.position, o.color);
    return this.attr("stroke", "url(#gradient-" + i + ")"), this;
  }
  dash(t = 3, n = "currentColor") {
    return this.strokeDasharray(t), this.strokeColor(n), this;
  }
  strokeDasharray(t, n) {
    if (typeof t == "undefined") {
      const r = this.attr("stroke-dasharray");
      if (typeof r == "number")
        return r;
      if (typeof r == "string") {
        const a = r.split(" ");
        return a.length === 1 ? isNaN(+a[0]) ? a[0] : +a[0] : a.map((c) => isNaN(+c) ? c : +c);
      }
    } else {
      if (typeof t == "string" || typeof t == "number")
        return this.attr("stroke-dasharray", t), this;
      if (Array.isArray(t))
        return this.attr("stroke-dasharray", t.join(" ")), this;
    }
    return null;
  }
  strokeDashoffset(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("stroke-dashoffset", t), this) : this.attr("stroke-dashoffset");
  }
  strokeLinecap(t) {
    if (typeof t == "undefined") {
      const n = this.attr("stroke-linecap");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("stroke-linecap", t), this;
    return null;
  }
  strokeLinejoin(t) {
    if (typeof t == "undefined") {
      const n = this.attr("stroke-linejoin");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("stroke-linejoin", t), this;
    return null;
  }
  strokeMiterlimit(t) {
    if (typeof t == "undefined") {
      const n = this.attr("stroke-miterlimit");
      return typeof n == "number" ? n : null;
    } else if (typeof t == "number")
      return this.attr("stroke-miterlimit", t), this;
    return null;
  }
  strokeOpacity(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("stroke-opacity", t), this) : this.attr("stroke-opacity");
  }
  strokeWidth(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("stroke-width", t), this) : this.attr("stroke-width");
  }
}
class VectorEffect extends SVGInstance {
  vectorEffect(t) {
    if (typeof t == "undefined") {
      const n = this.attr("vector-effect");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("vector-effect", t), this;
    return null;
  }
}
class Visibility extends SVGInstance {
  visibility(t) {
    if (typeof t == "undefined") {
      const n = this.attr("visibility");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("visibility", t), this;
    return null;
  }
}
class XYPositioning extends SVGInstance {
  moveTo(t, n) {
    return this.attr("x", t), this.attr("y", n), this;
  }
  moveBy(t, n) {
    var r, a;
    const c = (r = this.attr("x")) !== null && r !== void 0 ? r : 0 + t, d = (a = this.attr("y")) !== null && a !== void 0 ? a : 0 + n;
    return this.moveTo(c, d);
  }
  x(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("x", t), this) : this.attr("x");
  }
  y(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("y", t), this) : this.attr("y");
  }
}
class WidthHeight extends SVGInstance {
  width(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("width", t + ""), this) : this.attr("width");
  }
  height(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("height", t + ""), this) : this.attr("height");
  }
}
class SVGRectInstance extends SVGInstance {
  constructor(t) {
    super("rect", t);
  }
  borderRadius(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("rx", t), this.attr("ry", t), this) : this.attr("rx");
  }
}
applyMixins(SVGRectInstance, [
  Color,
  Display,
  Fill,
  Opacity,
  Stroke,
  VectorEffect,
  Visibility,
  XYPositioning,
  WidthHeight
]);
class CXCYPositioning extends SVGInstance {
  cx(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("cx", t), this) : this.attr("cx");
  }
  cy(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("cy", t), this) : this.attr("cy");
  }
}
class SVGCircleInstance extends SVGInstance {
  constructor(t) {
    super("circle", t);
  }
  radius(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("r", t), this) : this.attr("r");
  }
}
applyMixins(SVGCircleInstance, [
  Color,
  Display,
  Fill,
  Opacity,
  Stroke,
  VectorEffect,
  Visibility,
  CXCYPositioning
]);
class SVGLineInstance extends SVGInstance {
  constructor(t) {
    super("line", t);
  }
  x1(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("x1", t), this) : this.attr("x1");
  }
  y1(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("y1", t), this) : this.attr("y1");
  }
  x2(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("x2", t), this) : this.attr("x2");
  }
  y2(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("y2", t), this) : this.attr("y2");
  }
}
applyMixins(SVGLineInstance, [
  Color,
  Display,
  Fill,
  Opacity,
  Stroke,
  VectorEffect,
  Visibility
]);
class SVGPathInstance extends SVGInstance {
  constructor(t) {
    super("path", t);
  }
  lineTo(t, n, r = !1) {
    var a;
    let c = (a = this.attr("d")) !== null && a !== void 0 ? a : "";
    return c += r === !1 ? " L " : " l ", c += ` ${t}, ${n} `, this.attr("d", c), this;
  }
  moveTo(t, n, r = !1) {
    var a;
    let c = (a = this.attr("d")) !== null && a !== void 0 ? a : "";
    return c += r === !1 ? " M " : " m ", c += ` ${t}, ${n} `, this.attr("d", c), this;
  }
  cubicBezierCurveTo(t, n, r, a, c, d, u = !1) {
    var i;
    let o = (i = this.attr("d")) !== null && i !== void 0 ? i : "";
    return o += u === !1 ? " C " : " c ", o += ` ${t} ${n}, ${r} ${a}, ${c} ${d} `, this.attr("d", o), this;
  }
  smoothBezierCurveTo(t, n, r, a, c = !1) {
    var d;
    let u = (d = this.attr("d")) !== null && d !== void 0 ? d : "";
    return u += c === !1 ? " S " : " s ", u += ` ${t}, ${n} ${r}, ${a} `, this.attr("d", u), this;
  }
  quadraticBezierCurveTo(t, n, r, a, c = !1) {
    var d;
    let u = (d = this.attr("d")) !== null && d !== void 0 ? d : "";
    return u += c === !1 ? " Q " : " q ", u += ` ${t} ${n}, ${r} ${a} `, this.attr("d", u), this;
  }
  smoothQuadraticBezierCurveTo(t, n, r = !1) {
    var a;
    let c = (a = this.attr("d")) !== null && a !== void 0 ? a : "";
    return c += r === !1 ? " T " : " t ", c += ` ${t}, ${n} `, this.attr("d", c), this;
  }
  ellipticalArcCurveTo(t, n, r, a, c, d, u, i = !1) {
    var o;
    let s = (o = this.attr("d")) !== null && o !== void 0 ? o : "";
    return s += i === !1 ? " A " : " a ", s += ` ${t}, ${n} ${r} ${a ? 1 : 0} ${c ? 1 : 0} ${d} ${u} `, this.attr("d", s), this;
  }
  curveTo(t, n, r, a, c = !1) {
    var d;
    let u = (d = this.attr("d")) !== null && d !== void 0 ? d : "";
    return u += c === !1 ? " S " : " s ", u += ` ${t}, ${n} ${r}, ${a} `, this.attr("d", u), this;
  }
  close() {
    var t;
    let n = (t = this.attr("d")) !== null && t !== void 0 ? t : "";
    return n += " Z", this.attr("d", n), this;
  }
}
applyMixins(SVGPathInstance, [
  Color,
  Display,
  Fill,
  Opacity,
  Stroke,
  VectorEffect,
  Visibility
]);
class TextAttributes extends SVGInstance {
  text(t) {
    return typeof t == "string" ? (this.element.innerHTML = t, this) : this.element.innerHTML;
  }
  textAlign(t) {
    var n;
    return t === "left" ? this.textAnchor("start") : t === "center" ? this.textAnchor("middle") : t === "right" ? this.textAnchor("end") : (n = this.textAnchor()) !== null && n !== void 0 ? n : "left";
  }
  textAnchor(t) {
    if (typeof t == "undefined") {
      const n = this.attr("text-anchor");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("text-anchor", t), this;
    return null;
  }
  dx(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("dx", t), this) : this.attr("dx");
  }
  dy(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("dy", t), this) : this.attr("dy");
  }
}
class Font extends SVGInstance {
  fontFamily(t) {
    if (typeof t == "undefined") {
      const n = this.attr("font-family");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("font-family", t), this;
    return null;
  }
  fontSize(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("font-size", t), this) : this.attr("font-size");
  }
  fontStyle(t) {
    if (typeof t == "undefined") {
      const n = this.attr("font-style");
      return typeof n == "string" ? n : null;
    } else if (typeof t == "string")
      return this.attr("font-style", t), this;
    return null;
  }
  fontWeight(t) {
    return typeof t == "string" || typeof t == "number" ? (this.attr("font-weight", t), this) : this.attr("font-weight");
  }
}
class SVGTSpanInstance extends SVGInstance {
  constructor(t) {
    super("tspan", t);
  }
  addTSpan(t, n, r) {
    const a = new SVGTSpanInstance(this);
    return typeof t == "string" && typeof n == "undefined" ? a.text(t) : (typeof t == "string" || typeof t == "number") && (typeof n == "string" || typeof n == "number") && (a.attr("x", t), a.attr("y", n), typeof r == "string" && a.text(r)), this.appendInstance(a), a;
  }
}
applyMixins(SVGTSpanInstance, [
  Color,
  Display,
  Fill,
  Opacity,
  Stroke,
  VectorEffect,
  Visibility,
  XYPositioning,
  WidthHeight,
  TextAttributes,
  Font
]);
class SVGTextInstance extends SVGInstance {
  constructor(t) {
    super("text", t);
  }
  addTSpan(t, n, r) {
    const a = new SVGTSpanInstance(this);
    return typeof t == "string" && typeof n == "undefined" ? a.text(t) : (typeof t == "string" || typeof t == "number") && (typeof n == "string" || typeof n == "number") && (a.attr("x", t), a.attr("y", n), typeof r == "string" && a.text(r)), this.appendInstance(a), a;
  }
}
applyMixins(SVGTextInstance, [
  Color,
  Display,
  Fill,
  Opacity,
  Stroke,
  VectorEffect,
  Visibility,
  XYPositioning,
  WidthHeight,
  TextAttributes,
  Font
]);
class ShapeInstances extends SVGInstance {
  addRect(t, n, r, a) {
    const c = new SVGRectInstance(this);
    return t !== void 0 && c.attr("x", t + ""), n !== void 0 && c.attr("y", n + ""), r !== void 0 && c.attr("width", r + ""), a !== void 0 && c.attr("height", a + ""), this.appendInstance(c), c;
  }
  addCircle(t, n, r) {
    const a = new SVGCircleInstance(this);
    return t !== void 0 && a.attr("cx", t + ""), n !== void 0 && a.attr("cy", n + ""), r !== void 0 && a.attr("r", r + ""), this.appendInstance(a), a;
  }
  addLine(t, n, r, a) {
    const c = new SVGLineInstance(this);
    return t !== void 0 && c.attr("x1", t + ""), n !== void 0 && c.attr("y1", n + ""), r !== void 0 && c.attr("x2", r + ""), a !== void 0 && c.attr("y2", a + ""), this.appendInstance(c), c;
  }
  addPath(t) {
    const n = new SVGPathInstance(this);
    return t !== void 0 && n.attr("d", t + ""), this.appendInstance(n), n;
  }
  addText(t, n, r) {
    const a = new SVGTextInstance(this);
    return typeof t == "string" && typeof n == "undefined" ? a.text(t) : (typeof t == "string" || typeof t == "number") && (typeof n == "string" || typeof n == "number") && (a.attr("x", t), a.attr("y", n), typeof r == "string" && a.text(r)), this.appendInstance(a), a;
  }
}
class SVGGroupInstance extends SVGInstance {
  constructor(t) {
    super("g", t);
  }
  addGroup() {
    const t = new SVGGroupInstance(this);
    return this.appendInstance(t), t;
  }
  addSVG(t, n) {
    if (typeof t != "undefined" && typeof n != "undefined") {
      const r = new SVGSVGInstance(t, n);
      return this.appendInstance(r), r;
    } else {
      const r = new SVGSVGInstance();
      return this.appendInstance(r), r;
    }
  }
}
applyMixins(SVGGroupInstance, [
  ShapeInstances,
  Color,
  Display,
  Fill,
  Opacity,
  Stroke,
  VectorEffect,
  Visibility
]);
class StructuralInstances extends SVGInstance {
  addGroup() {
    const t = new SVGGroupInstance(this);
    return this.appendInstance(t), t;
  }
  addSVG(t, n) {
    if (typeof t != "undefined" && typeof n != "undefined") {
      const r = new SVGSVGInstance(t, n);
      return this.appendInstance(r), r;
    } else {
      const r = new SVGSVGInstance();
      return this.appendInstance(r), r;
    }
  }
}
class SVGStopInstance extends SVGInstance {
  constructor(t) {
    super("stop", t);
  }
}
applyMixins(SVGStopInstance, [
  Color,
  Display,
  Fill,
  Opacity,
  Stroke,
  VectorEffect,
  Visibility
]);
class GradientStopInstances extends SVGInstance {
  addStop(t, n) {
    const r = new SVGStopInstance(this);
    return r.attr("offset", t), r.attr("stop-color", n), this.appendInstance(r), r;
  }
}
class SVGLinearGradientInstance extends SVGInstance {
  constructor(t) {
    super("linearGradient", t);
  }
}
applyMixins(SVGLinearGradientInstance, [
  GradientStopInstances,
  Color,
  Display,
  Fill,
  Opacity,
  Stroke,
  VectorEffect,
  Visibility
]);
class GradientInstances extends SVGInstance {
  addLinearGradient() {
    const t = new SVGLinearGradientInstance(this);
    return this.appendInstance(t), t;
  }
}
class SVGDefsInstance extends SVGInstance {
  constructor(t) {
    super("defs", t);
  }
}
applyMixins(SVGDefsInstance, [
  ShapeInstances,
  StructuralInstances,
  GradientInstances,
  Color,
  Display,
  Fill,
  Opacity,
  Stroke,
  VectorEffect,
  Visibility
]);
class DescriptiveInstances extends SVGInstance {
  addDefs() {
    const t = new SVGDefsInstance(this);
    return this.appendInstance(t), t;
  }
}
class PreserveAspectRatio extends SVGInstance {
  preserveAspectRatio(t, n) {
    if (typeof t == "undefined" && typeof n == "undefined") {
      const r = this.attr("preserveAspectRatio");
      if (typeof r == "string") {
        const [a, c] = r.split(" ");
        return { align: a, meetOrSlice: c };
      }
    } else {
      if (typeof t == "string" && typeof n == "string")
        return this.attr("preserveAspectRatio", `${t} ${n}`), this;
      if (typeof t == "string" && typeof n == "undefined")
        return this.attr("preserveAspectRatio", t), this;
    }
    return null;
  }
}
class SVGSVGInstance extends SVGInstance {
  constructor(t, n, r) {
    super("svg"), (typeof t == "string" || typeof t == "number") && this.width(t), (typeof n == "string" || typeof n == "number") && this.height(n);
  }
  addGroup() {
    const t = new SVGGroupInstance(this);
    return this.appendInstance(t), t;
  }
  addSVG(t, n) {
    if (typeof t != "undefined" && typeof n != "undefined") {
      const r = new SVGSVGInstance(t, n);
      return this.appendInstance(r), r;
    } else {
      const r = new SVGSVGInstance();
      return this.appendInstance(r), r;
    }
  }
  viewBox(t, n, r, a) {
    if (typeof t == "undefined") {
      const c = this.attr("viewBox");
      if (typeof c == "string") {
        const [d, u, i, o] = c.split(" ");
        return {
          x: isNaN(+d) ? d : +d,
          y: isNaN(+u) ? u : +u,
          width: isNaN(+i) ? i : +i,
          height: isNaN(+o) ? o : +o
        };
      }
      return null;
    } else if ((typeof t == "string" || typeof t == "number") && (typeof n == "string" || typeof n == "number") && (typeof r == "string" || typeof r == "number") && (typeof a == "string" || typeof a == "number"))
      return this.attr("viewBox", `${t} ${n} ${r} ${a}`), this;
    return null;
  }
}
applyMixins(SVGSVGInstance, [
  ShapeInstances,
  StructuralInstances,
  DescriptiveInstances,
  Color,
  Display,
  Fill,
  Opacity,
  Stroke,
  VectorEffect,
  Visibility,
  PreserveAspectRatio,
  XYPositioning,
  WidthHeight
]);
class SVG extends SVGSVGInstance {
  constructor() {
    super(), this.attr("xmlns", "http://www.w3.org/2000/svg");
  }
}
function calc(expression, unit = "px") {
  const expressionWithoutUnits = convertAbsoluteUnitsInStringToPixels(expression), sanitizedExpression = expressionWithoutUnits.replace(/[^-()\d/*+.]/g, ""), result = +eval(sanitizedExpression);
  switch (unit) {
    case "cm":
      return px2cm(result);
    case "mm":
      return px2mm(result);
    case "in":
      return px2in(result);
    case "pt":
      return px2pt(result);
    case "pc":
      return px2pc(result);
    case "px":
      return result;
  }
}
function convertAbsoluteUnitsInStringToPixels(e) {
  const t = (a, c, d, u) => a.substr(0, d) + u + a.substr(d + c.length), n = /(-?\d*\.?\d+)(mm|cm|in|pt|pc|px)+/g;
  let r;
  for (; (r = n.exec(e)) !== null; )
    switch (r[2]) {
      case "cm":
        e = t(e, r[0], r.index, cm2px(+r[1]) + "");
        break;
      case "mm":
        e = t(e, r[0], r.index, mm2px$1(+r[1]) + "");
        break;
      case "in":
        e = t(e, r[0], r.index, in2px(+r[1]) + "");
        break;
      case "pt":
        e = t(e, r[0], r.index, pt2px(+r[1]) + "");
        break;
      case "pc":
        e = t(e, r[0], r.index, pc2px(+r[1]) + "");
        break;
      case "px":
        e = t(e, r[0], r.index, +r[1] + "");
        break;
    }
  return e;
}
function cm2px(e) {
  return e * 9600 / 254;
}
function px2cm(e) {
  return e * 254 / 9600;
}
function mm2px$1(e) {
  return e * 960 / 254;
}
function px2mm(e) {
  return e * 254 / 960;
}
function in2px(e) {
  return e * 960;
}
function px2in(e) {
  return e / 960;
}
function pt2px(e) {
  return e * 4 / 3;
}
function px2pt(e) {
  return e / 4 * 3;
}
function pc2px(e) {
  return e * 16;
}
function px2pc(e) {
  return e / 16;
}
function cleanData(e) {
  const t = (n) => Object.fromEntries(
    Object.entries(n).map(([r, a]) => typeof a == "object" ? [r, t(a)] : typeof a == "string" ? r === "account" ? [r, removeLineBreaks(removeSpaces(a))] : r === "reference" ? [r, removeLineBreaks(removeSpaces(a))] : r === "country" ? [r, removeLineBreaks(removeSpaces(a).toUpperCase())] : [r, removeLineBreaks(a)] : [r, a])
  );
  return t(e);
}
function removeSpaces(e) {
  return e.replace(/ /g, "");
}
function removeLineBreaks(e) {
  return e.replace(/\n/g, "").replace(/\r/g, "");
}
function isQRIBAN(e) {
  e = e.replace(/ /g, "");
  const t = e.substring(4, 9);
  return +t >= 3e4 && +t <= 31999;
}
function isIBANValid(e) {
  return e = e.replace(/ /g, "").toUpperCase(), e = e.substring(4) + e.substring(0, 4), mod97(e) === 1;
}
function formatIBAN(e) {
  var n;
  const t = e.replace(/ /g, "").match(/.{1,4}/g);
  return (n = t == null ? void 0 : t.join(" ")) != null ? n : e;
}
function isQRReference(e) {
  return e = e.replace(/ /g, ""), !(e.length !== 27 || !/^\d+$/.test(e));
}
function isQRReferenceValid(e) {
  if (e = e.replace(/ /g, ""), !isQRReference(e))
    return !1;
  const t = e.substring(0, 26), n = e.substring(26, 27);
  return calculateQRReferenceChecksum(t) === n;
}
function calculateQRReferenceChecksum(e) {
  return mod10(e);
}
function formatQRReference(e) {
  const t = e.replace(/ /g, ""), n = t.substring(2).match(/.{1,5}/g);
  return n ? `${t.substring(0, 2)} ${n.join(" ")}` : e;
}
function formatSCORReference(e) {
  var r;
  const n = e.replace(/ /g, "").match(/.{1,4}/g);
  return (r = n == null ? void 0 : n.join(" ")) != null ? r : e;
}
function formatReference(e) {
  const t = getReferenceType(e);
  return t === "QRR" ? formatQRReference(e) : t === "SCOR" ? formatSCORReference(e) : e;
}
function formatAmount(e) {
  const n = e.toFixed(2).split(".");
  let r = "";
  for (let a = n[0].length - 1, c = 1; a >= 0; a--, c++)
    r = n[0][a] + r, c === 3 && (r = ` ${r}`, c = 0);
  return `${r.trim()}.${n[1]}`;
}
function mm2px(e) {
  return e * 960 / 254;
}
function getReferenceType(e) {
  return typeof e == "undefined" ? "NON" : isQRReference(e) ? "QRR" : "SCOR";
}
function mod97(e) {
  const t = "A".charCodeAt(0), n = e.split("");
  for (let a = 0; a < n.length; a++) {
    const c = n[a].charCodeAt(0);
    c >= t && (n[a] = `${c - t + 10}`);
  }
  e = n.join("");
  let r = 0;
  for (let a = 0; a < e.length; a++) {
    const c = +e[a];
    r = (10 * r + c) % 97;
  }
  return r;
}
function mod10(e) {
  const t = e.replace(/ /g, ""), n = [0, 9, 4, 6, 8, 2, 7, 1, 3, 5];
  let r = 0;
  for (let a = 0; a < t.length; a++)
    r = n[(r + parseInt(t.substring(a, a + 1), 10)) % 10];
  return ((10 - r) % 10).toString();
}
var qrcodegen;
((e) => {
  const t = class _ {
    /*-- Constructor (low level) and fields --*/
    // Creates a new QR Code with the given version number,
    // error correction level, data codeword bytes, and mask number.
    // This is a low-level API that most users should not use directly.
    // A mid-level API is the encodeSegments() function.
    constructor(i, o, s, l) {
      if (this.version = i, this.errorCorrectionLevel = o, this.modules = [], this.isFunction = [], i < _.MIN_VERSION || i > _.MAX_VERSION)
        throw "Version value out of range";
      if (l < -1 || l > 7)
        throw "Mask value out of range";
      this.size = i * 4 + 17;
      const f = [];
      for (let h = 0; h < this.size; h++)
        f.push(!1);
      for (let h = 0; h < this.size; h++)
        this.modules.push(f.slice()), this.isFunction.push(f.slice());
      this.drawFunctionPatterns();
      const m = this.addEccAndInterleave(s);
      if (this.drawCodewords(m), l == -1) {
        let h = 1e9;
        for (let I = 0; I < 8; I++) {
          this.applyMask(I), this.drawFormatBits(I);
          const E = this.getPenaltyScore();
          E < h && (l = I, h = E), this.applyMask(I);
        }
      }
      a(0 <= l && l <= 7), this.mask = l, this.applyMask(l), this.drawFormatBits(l), this.isFunction = [];
    }
    /*-- Static factory functions (high level) --*/
    // Returns a QR Code representing the given Unicode text string at the given error correction level.
    // As a conservative upper bound, this function is guaranteed to succeed for strings that have 738 or fewer
    // Unicode code points (not UTF-16 code units) if the low error correction level is used. The smallest possible
    // QR Code version is automatically chosen for the output. The ECC level of the result may be higher than the
    // ecl argument if it can be done without increasing the version.
    static encodeText(i, o) {
      const s = e.QrSegment.makeSegments(i);
      return _.encodeSegments(s, o);
    }
    // Returns a QR Code representing the given binary data at the given error correction level.
    // This function always encodes using the binary segment mode, not any text mode. The maximum number of
    // bytes allowed is 2953. The smallest possible QR Code version is automatically chosen for the output.
    // The ECC level of the result may be higher than the ecl argument if it can be done without increasing the version.
    static encodeBinary(i, o) {
      const s = e.QrSegment.makeBytes(i);
      return _.encodeSegments([s], o);
    }
    /*-- Static factory functions (mid level) --*/
    // Returns a QR Code representing the given segments with the given encoding parameters.
    // The smallest possible QR Code version within the given range is automatically
    // chosen for the output. Iff boostEcl is true, then the ECC level of the result
    // may be higher than the ecl argument if it can be done without increasing the
    // version. The mask number is either between 0 to 7 (inclusive) to force that
    // mask, or -1 to automatically choose an appropriate mask (which may be slow).
    // This function allows the user to create a custom sequence of segments that switches
    // between modes (such as alphanumeric and byte) to encode text in less space.
    // This is a mid-level API; the high-level API is encodeText() and encodeBinary().
    static encodeSegments(i, o, s = 1, l = 40, f = -1, m = !0) {
      if (!(_.MIN_VERSION <= s && s <= l && l <= _.MAX_VERSION) || f < -1 || f > 7)
        throw "Invalid value";
      let h, I;
      for (h = s; ; h++) {
        const p = _.getNumDataCodewords(h, o) * 8, N = d.getTotalBits(i, h);
        if (N <= p) {
          I = N;
          break;
        }
        if (h >= l)
          throw "Data too long";
      }
      for (const p of [_.Ecc.MEDIUM, _.Ecc.QUARTILE, _.Ecc.HIGH])
        m && I <= _.getNumDataCodewords(h, p) * 8 && (o = p);
      const E = [];
      for (const p of i) {
        n(p.mode.modeBits, 4, E), n(p.numChars, p.mode.numCharCountBits(h), E);
        for (const N of p.getData())
          E.push(N);
      }
      a(E.length == I);
      const g = _.getNumDataCodewords(h, o) * 8;
      a(E.length <= g), n(0, Math.min(4, g - E.length), E), n(0, (8 - E.length % 8) % 8, E), a(E.length % 8 == 0);
      for (let p = 236; E.length < g; p ^= 253)
        n(p, 8, E);
      const y = [];
      for (; y.length * 8 < E.length; )
        y.push(0);
      return E.forEach((p, N) => y[N >>> 3] |= p << 7 - (N & 7)), new _(h, o, y, f);
    }
    /*-- Accessor methods --*/
    // Returns the color of the module (pixel) at the given coordinates, which is false
    // for light or true for dark. The top left corner has the coordinates (x=0, y=0).
    // If the given coordinates are out of bounds, then false (light) is returned.
    getModule(i, o) {
      return 0 <= i && i < this.size && 0 <= o && o < this.size && this.modules[o][i];
    }
    /*-- Private helper methods for constructor: Drawing function modules --*/
    // Reads this object's version field, and draws and marks all function modules.
    drawFunctionPatterns() {
      for (let s = 0; s < this.size; s++)
        this.setFunctionModule(6, s, s % 2 == 0), this.setFunctionModule(s, 6, s % 2 == 0);
      this.drawFinderPattern(3, 3), this.drawFinderPattern(this.size - 4, 3), this.drawFinderPattern(3, this.size - 4);
      const i = this.getAlignmentPatternPositions(), o = i.length;
      for (let s = 0; s < o; s++)
        for (let l = 0; l < o; l++)
          s == 0 && l == 0 || s == 0 && l == o - 1 || s == o - 1 && l == 0 || this.drawAlignmentPattern(i[s], i[l]);
      this.drawFormatBits(0), this.drawVersion();
    }
    // Draws two copies of the format bits (with its own error correction code)
    // based on the given mask and this object's error correction level field.
    drawFormatBits(i) {
      const o = this.errorCorrectionLevel.formatBits << 3 | i;
      let s = o;
      for (let f = 0; f < 10; f++)
        s = s << 1 ^ (s >>> 9) * 1335;
      const l = (o << 10 | s) ^ 21522;
      a(l >>> 15 == 0);
      for (let f = 0; f <= 5; f++)
        this.setFunctionModule(8, f, r(l, f));
      this.setFunctionModule(8, 7, r(l, 6)), this.setFunctionModule(8, 8, r(l, 7)), this.setFunctionModule(7, 8, r(l, 8));
      for (let f = 9; f < 15; f++)
        this.setFunctionModule(14 - f, 8, r(l, f));
      for (let f = 0; f < 8; f++)
        this.setFunctionModule(this.size - 1 - f, 8, r(l, f));
      for (let f = 8; f < 15; f++)
        this.setFunctionModule(8, this.size - 15 + f, r(l, f));
      this.setFunctionModule(8, this.size - 8, !0);
    }
    // Draws two copies of the version bits (with its own error correction code),
    // based on this object's version field, iff 7 <= version <= 40.
    drawVersion() {
      if (this.version < 7)
        return;
      let i = this.version;
      for (let s = 0; s < 12; s++)
        i = i << 1 ^ (i >>> 11) * 7973;
      const o = this.version << 12 | i;
      a(o >>> 18 == 0);
      for (let s = 0; s < 18; s++) {
        const l = r(o, s), f = this.size - 11 + s % 3, m = Math.floor(s / 3);
        this.setFunctionModule(f, m, l), this.setFunctionModule(m, f, l);
      }
    }
    // Draws a 9*9 finder pattern including the border separator,
    // with the center module at (x, y). Modules can be out of bounds.
    drawFinderPattern(i, o) {
      for (let s = -4; s <= 4; s++)
        for (let l = -4; l <= 4; l++) {
          const f = Math.max(Math.abs(l), Math.abs(s)), m = i + l, h = o + s;
          0 <= m && m < this.size && 0 <= h && h < this.size && this.setFunctionModule(m, h, f != 2 && f != 4);
        }
    }
    // Draws a 5*5 alignment pattern, with the center module
    // at (x, y). All modules must be in bounds.
    drawAlignmentPattern(i, o) {
      for (let s = -2; s <= 2; s++)
        for (let l = -2; l <= 2; l++)
          this.setFunctionModule(i + l, o + s, Math.max(Math.abs(l), Math.abs(s)) != 1);
    }
    // Sets the color of a module and marks it as a function module.
    // Only used by the constructor. Coordinates must be in bounds.
    setFunctionModule(i, o, s) {
      this.modules[o][i] = s, this.isFunction[o][i] = !0;
    }
    /*-- Private helper methods for constructor: Codewords and masking --*/
    // Returns a new byte string representing the given data with the appropriate error correction
    // codewords appended to it, based on this object's version and error correction level.
    addEccAndInterleave(i) {
      const o = this.version, s = this.errorCorrectionLevel;
      if (i.length != _.getNumDataCodewords(o, s))
        throw "Invalid argument";
      const l = _.NUM_ERROR_CORRECTION_BLOCKS[s.ordinal][o], f = _.ECC_CODEWORDS_PER_BLOCK[s.ordinal][o], m = Math.floor(_.getNumRawDataModules(o) / 8), h = l - m % l, I = Math.floor(m / l), E = [], g = _.reedSolomonComputeDivisor(f);
      for (let p = 0, N = 0; p < l; p++) {
        const T = i.slice(N, N + I - f + (p < h ? 0 : 1));
        N += T.length;
        const R = _.reedSolomonComputeRemainder(T, g);
        p < h && T.push(0), E.push(T.concat(R));
      }
      const y = [];
      for (let p = 0; p < E[0].length; p++)
        E.forEach((N, T) => {
          (p != I - f || T >= h) && y.push(N[p]);
        });
      return a(y.length == m), y;
    }
    // Draws the given sequence of 8-bit codewords (data and error correction) onto the entire
    // data area of this QR Code. Function modules need to be marked off before this is called.
    drawCodewords(i) {
      if (i.length != Math.floor(_.getNumRawDataModules(this.version) / 8))
        throw "Invalid argument";
      let o = 0;
      for (let s = this.size - 1; s >= 1; s -= 2) {
        s == 6 && (s = 5);
        for (let l = 0; l < this.size; l++)
          for (let f = 0; f < 2; f++) {
            const m = s - f, I = (s + 1 & 2) == 0 ? this.size - 1 - l : l;
            !this.isFunction[I][m] && o < i.length * 8 && (this.modules[I][m] = r(i[o >>> 3], 7 - (o & 7)), o++);
          }
      }
      a(o == i.length * 8);
    }
    // XORs the codeword modules in this QR Code with the given mask pattern.
    // The function modules must be marked and the codeword bits must be drawn
    // before masking. Due to the arithmetic of XOR, calling applyMask() with
    // the same mask value a second time will undo the mask. A final well-formed
    // QR Code needs exactly one (not zero, two, etc.) mask applied.
    applyMask(i) {
      if (i < 0 || i > 7)
        throw "Mask value out of range";
      for (let o = 0; o < this.size; o++)
        for (let s = 0; s < this.size; s++) {
          let l;
          switch (i) {
            case 0:
              l = (s + o) % 2 == 0;
              break;
            case 1:
              l = o % 2 == 0;
              break;
            case 2:
              l = s % 3 == 0;
              break;
            case 3:
              l = (s + o) % 3 == 0;
              break;
            case 4:
              l = (Math.floor(s / 3) + Math.floor(o / 2)) % 2 == 0;
              break;
            case 5:
              l = s * o % 2 + s * o % 3 == 0;
              break;
            case 6:
              l = (s * o % 2 + s * o % 3) % 2 == 0;
              break;
            case 7:
              l = ((s + o) % 2 + s * o % 3) % 2 == 0;
              break;
            default:
              throw "Unreachable";
          }
          !this.isFunction[o][s] && l && (this.modules[o][s] = !this.modules[o][s]);
        }
    }
    // Calculates and returns the penalty score based on state of this QR Code's current modules.
    // This is used by the automatic mask choice algorithm to find the mask pattern that yields the lowest score.
    getPenaltyScore() {
      let i = 0;
      for (let f = 0; f < this.size; f++) {
        let m = !1, h = 0;
        const I = [0, 0, 0, 0, 0, 0, 0];
        for (let E = 0; E < this.size; E++)
          this.modules[f][E] == m ? (h++, h == 5 ? i += _.PENALTY_N1 : h > 5 && i++) : (this.finderPenaltyAddHistory(h, I), m || (i += this.finderPenaltyCountPatterns(I) * _.PENALTY_N3), m = this.modules[f][E], h = 1);
        i += this.finderPenaltyTerminateAndCount(m, h, I) * _.PENALTY_N3;
      }
      for (let f = 0; f < this.size; f++) {
        let m = !1, h = 0;
        const I = [0, 0, 0, 0, 0, 0, 0];
        for (let E = 0; E < this.size; E++)
          this.modules[E][f] == m ? (h++, h == 5 ? i += _.PENALTY_N1 : h > 5 && i++) : (this.finderPenaltyAddHistory(h, I), m || (i += this.finderPenaltyCountPatterns(I) * _.PENALTY_N3), m = this.modules[E][f], h = 1);
        i += this.finderPenaltyTerminateAndCount(m, h, I) * _.PENALTY_N3;
      }
      for (let f = 0; f < this.size - 1; f++)
        for (let m = 0; m < this.size - 1; m++) {
          const h = this.modules[f][m];
          h == this.modules[f][m + 1] && h == this.modules[f + 1][m] && h == this.modules[f + 1][m + 1] && (i += _.PENALTY_N2);
        }
      let o = 0;
      for (const f of this.modules)
        o = f.reduce((m, h) => m + (h ? 1 : 0), o);
      const s = this.size * this.size, l = Math.ceil(Math.abs(o * 20 - s * 10) / s) - 1;
      return a(0 <= l && l <= 9), i += l * _.PENALTY_N4, a(0 <= i && i <= 2568888), i;
    }
    /*-- Private helper functions --*/
    // Returns an ascending list of positions of alignment patterns for this version number.
    // Each position is in the range [0,177), and are used on both the x and y axes.
    // This could be implemented as lookup table of 40 variable-length lists of integers.
    getAlignmentPatternPositions() {
      if (this.version == 1)
        return [];
      {
        const i = Math.floor(this.version / 7) + 2, o = this.version == 32 ? 26 : Math.ceil((this.version * 4 + 4) / (i * 2 - 2)) * 2, s = [6];
        for (let l = this.size - 7; s.length < i; l -= o)
          s.splice(1, 0, l);
        return s;
      }
    }
    // Returns the number of data bits that can be stored in a QR Code of the given version number, after
    // all function modules are excluded. This includes remainder bits, so it might not be a multiple of 8.
    // The result is in the range [208, 29648]. This could be implemented as a 40-entry lookup table.
    static getNumRawDataModules(i) {
      if (i < _.MIN_VERSION || i > _.MAX_VERSION)
        throw "Version number out of range";
      let o = (16 * i + 128) * i + 64;
      if (i >= 2) {
        const s = Math.floor(i / 7) + 2;
        o -= (25 * s - 10) * s - 55, i >= 7 && (o -= 36);
      }
      return a(208 <= o && o <= 29648), o;
    }
    // Returns the number of 8-bit data (i.e. not error correction) codewords contained in any
    // QR Code of the given version number and error correction level, with remainder bits discarded.
    // This stateless pure function could be implemented as a (40*4)-cell lookup table.
    static getNumDataCodewords(i, o) {
      return Math.floor(_.getNumRawDataModules(i) / 8) - _.ECC_CODEWORDS_PER_BLOCK[o.ordinal][i] * _.NUM_ERROR_CORRECTION_BLOCKS[o.ordinal][i];
    }
    // Returns a Reed-Solomon ECC generator polynomial for the given degree. This could be
    // implemented as a lookup table over all possible parameter values, instead of as an algorithm.
    static reedSolomonComputeDivisor(i) {
      if (i < 1 || i > 255)
        throw "Degree out of range";
      const o = [];
      for (let l = 0; l < i - 1; l++)
        o.push(0);
      o.push(1);
      let s = 1;
      for (let l = 0; l < i; l++) {
        for (let f = 0; f < o.length; f++)
          o[f] = _.reedSolomonMultiply(o[f], s), f + 1 < o.length && (o[f] ^= o[f + 1]);
        s = _.reedSolomonMultiply(s, 2);
      }
      return o;
    }
    // Returns the Reed-Solomon error correction codeword for the given data and divisor polynomials.
    static reedSolomonComputeRemainder(i, o) {
      const s = o.map((l) => 0);
      for (const l of i) {
        const f = l ^ s.shift();
        s.push(0), o.forEach((m, h) => s[h] ^= _.reedSolomonMultiply(m, f));
      }
      return s;
    }
    // Returns the product of the two given field elements modulo GF(2^8/0x11D). The arguments and result
    // are unsigned 8-bit integers. This could be implemented as a lookup table of 256*256 entries of uint8.
    static reedSolomonMultiply(i, o) {
      if (i >>> 8 || o >>> 8)
        throw "Byte out of range";
      let s = 0;
      for (let l = 7; l >= 0; l--)
        s = s << 1 ^ (s >>> 7) * 285, s ^= (o >>> l & 1) * i;
      return a(s >>> 8 == 0), s;
    }
    // Can only be called immediately after a light run is added, and
    // returns either 0, 1, or 2. A helper function for getPenaltyScore().
    finderPenaltyCountPatterns(i) {
      const o = i[1];
      a(o <= this.size * 3);
      const s = o > 0 && i[2] == o && i[3] == o * 3 && i[4] == o && i[5] == o;
      return (s && i[0] >= o * 4 && i[6] >= o ? 1 : 0) + (s && i[6] >= o * 4 && i[0] >= o ? 1 : 0);
    }
    // Must be called at the end of a line (row or column) of modules. A helper function for getPenaltyScore().
    finderPenaltyTerminateAndCount(i, o, s) {
      return i && (this.finderPenaltyAddHistory(o, s), o = 0), o += this.size, this.finderPenaltyAddHistory(o, s), this.finderPenaltyCountPatterns(s);
    }
    // Pushes the given value to the front and drops the last value. A helper function for getPenaltyScore().
    finderPenaltyAddHistory(i, o) {
      o[0] == 0 && (i += this.size), o.pop(), o.unshift(i);
    }
  };
  t.MIN_VERSION = 1, t.MAX_VERSION = 40, t.PENALTY_N1 = 3, t.PENALTY_N2 = 3, t.PENALTY_N3 = 40, t.PENALTY_N4 = 10, t.ECC_CODEWORDS_PER_BLOCK = [
    // Version: (note that index 0 is for padding, and is set to an illegal value)
    //0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40    Error correction level
    [-1, 7, 10, 15, 20, 26, 18, 20, 24, 30, 18, 20, 24, 26, 30, 22, 24, 28, 30, 28, 28, 28, 28, 30, 30, 26, 28, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30],
    // Low
    [-1, 10, 16, 26, 18, 24, 16, 18, 22, 22, 26, 30, 22, 22, 24, 24, 28, 28, 26, 26, 26, 26, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28],
    // Medium
    [-1, 13, 22, 18, 26, 18, 24, 18, 22, 20, 24, 28, 26, 24, 20, 30, 24, 28, 28, 26, 30, 28, 30, 30, 30, 30, 28, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30],
    // Quartile
    [-1, 17, 28, 22, 16, 22, 28, 26, 26, 24, 28, 24, 28, 22, 24, 24, 30, 28, 28, 26, 28, 30, 24, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30]
    // High
  ], t.NUM_ERROR_CORRECTION_BLOCKS = [
    // Version: (note that index 0 is for padding, and is set to an illegal value)
    //0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40    Error correction level
    [-1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 4, 4, 4, 4, 4, 6, 6, 6, 6, 7, 8, 8, 9, 9, 10, 12, 12, 12, 13, 14, 15, 16, 17, 18, 19, 19, 20, 21, 22, 24, 25],
    // Low
    [-1, 1, 1, 1, 2, 2, 4, 4, 4, 5, 5, 5, 8, 9, 9, 10, 10, 11, 13, 14, 16, 17, 17, 18, 20, 21, 23, 25, 26, 28, 29, 31, 33, 35, 37, 38, 40, 43, 45, 47, 49],
    // Medium
    [-1, 1, 1, 2, 2, 4, 4, 6, 6, 8, 8, 8, 10, 12, 16, 12, 17, 16, 18, 21, 20, 23, 23, 25, 27, 29, 34, 34, 35, 38, 40, 43, 45, 48, 51, 53, 56, 59, 62, 65, 68],
    // Quartile
    [-1, 1, 1, 2, 4, 4, 4, 5, 6, 8, 8, 11, 11, 16, 16, 18, 16, 19, 21, 25, 25, 25, 34, 30, 32, 35, 37, 40, 42, 45, 48, 51, 54, 57, 60, 63, 66, 70, 74, 77, 81]
    // High
  ], e.QrCode = t;
  function n(u, i, o) {
    if (i < 0 || i > 31 || u >>> i)
      throw "Value out of range";
    for (let s = i - 1; s >= 0; s--)
      o.push(u >>> s & 1);
  }
  function r(u, i) {
    return (u >>> i & 1) != 0;
  }
  function a(u) {
    if (!u)
      throw "Assertion error";
  }
  const c = class S {
    /*-- Constructor (low level) and fields --*/
    // Creates a new QR Code segment with the given attributes and data.
    // The character count (numChars) must agree with the mode and the bit buffer length,
    // but the constraint isn't checked. The given bit buffer is cloned and stored.
    constructor(i, o, s) {
      if (this.mode = i, this.numChars = o, this.bitData = s, o < 0)
        throw "Invalid argument";
      this.bitData = s.slice();
    }
    /*-- Static factory functions (mid level) --*/
    // Returns a segment representing the given binary data encoded in
    // byte mode. All input byte arrays are acceptable. Any text string
    // can be converted to UTF-8 bytes and encoded as a byte mode segment.
    static makeBytes(i) {
      const o = [];
      for (const s of i)
        n(s, 8, o);
      return new S(S.Mode.BYTE, i.length, o);
    }
    // Returns a segment representing the given string of decimal digits encoded in numeric mode.
    static makeNumeric(i) {
      if (!S.isNumeric(i))
        throw "String contains non-numeric characters";
      const o = [];
      for (let s = 0; s < i.length; ) {
        const l = Math.min(i.length - s, 3);
        n(parseInt(i.substr(s, l), 10), l * 3 + 1, o), s += l;
      }
      return new S(S.Mode.NUMERIC, i.length, o);
    }
    // Returns a segment representing the given text string encoded in alphanumeric mode.
    // The characters allowed are: 0 to 9, A to Z (uppercase only), space,
    // dollar, percent, asterisk, plus, hyphen, period, slash, colon.
    static makeAlphanumeric(i) {
      if (!S.isAlphanumeric(i))
        throw "String contains unencodable characters in alphanumeric mode";
      const o = [];
      let s;
      for (s = 0; s + 2 <= i.length; s += 2) {
        let l = S.ALPHANUMERIC_CHARSET.indexOf(i.charAt(s)) * 45;
        l += S.ALPHANUMERIC_CHARSET.indexOf(i.charAt(s + 1)), n(l, 11, o);
      }
      return s < i.length && n(S.ALPHANUMERIC_CHARSET.indexOf(i.charAt(s)), 6, o), new S(S.Mode.ALPHANUMERIC, i.length, o);
    }
    // Returns a new mutable list of zero or more segments to represent the given Unicode text string.
    // The result may use various segment modes and switch modes to optimize the length of the bit stream.
    static makeSegments(i) {
      return i == "" ? [] : S.isNumeric(i) ? [S.makeNumeric(i)] : S.isAlphanumeric(i) ? [S.makeAlphanumeric(i)] : [S.makeBytes(S.toUtf8ByteArray(i))];
    }
    // Returns a segment representing an Extended Channel Interpretation
    // (ECI) designator with the given assignment value.
    static makeEci(i) {
      const o = [];
      if (i < 0)
        throw "ECI assignment value out of range";
      if (i < 128)
        n(i, 8, o);
      else if (i < 16384)
        n(2, 2, o), n(i, 14, o);
      else if (i < 1e6)
        n(6, 3, o), n(i, 21, o);
      else
        throw "ECI assignment value out of range";
      return new S(S.Mode.ECI, 0, o);
    }
    // Tests whether the given string can be encoded as a segment in numeric mode.
    // A string is encodable iff each character is in the range 0 to 9.
    static isNumeric(i) {
      return S.NUMERIC_REGEX.test(i);
    }
    // Tests whether the given string can be encoded as a segment in alphanumeric mode.
    // A string is encodable iff each character is in the following set: 0 to 9, A to Z
    // (uppercase only), space, dollar, percent, asterisk, plus, hyphen, period, slash, colon.
    static isAlphanumeric(i) {
      return S.ALPHANUMERIC_REGEX.test(i);
    }
    /*-- Methods --*/
    // Returns a new copy of the data bits of this segment.
    getData() {
      return this.bitData.slice();
    }
    // (Package-private) Calculates and returns the number of bits needed to encode the given segments at
    // the given version. The result is infinity if a segment has too many characters to fit its length field.
    static getTotalBits(i, o) {
      let s = 0;
      for (const l of i) {
        const f = l.mode.numCharCountBits(o);
        if (l.numChars >= 1 << f)
          return 1 / 0;
        s += 4 + f + l.bitData.length;
      }
      return s;
    }
    // Returns a new array of bytes representing the given string encoded in UTF-8.
    static toUtf8ByteArray(i) {
      i = encodeURI(i);
      const o = [];
      for (let s = 0; s < i.length; s++)
        i.charAt(s) != "%" ? o.push(i.charCodeAt(s)) : (o.push(parseInt(i.substr(s + 1, 2), 16)), s += 2);
      return o;
    }
  };
  c.NUMERIC_REGEX = /^[0-9]*$/, c.ALPHANUMERIC_REGEX = /^[A-Z0-9 $%*+.\/:-]*$/, c.ALPHANUMERIC_CHARSET = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ $%*+-./:";
  let d = c;
  e.QrSegment = c;
})(qrcodegen || (qrcodegen = {}));
((e) => {
  ((t) => {
    const n = class {
      // The QR Code can tolerate about 30% erroneous codewords
      /*-- Constructor and fields --*/
      constructor(a, c) {
        this.ordinal = a, this.formatBits = c;
      }
    };
    n.LOW = new n(0, 1), n.MEDIUM = new n(1, 0), n.QUARTILE = new n(2, 3), n.HIGH = new n(3, 2), t.Ecc = n;
  })(e.QrCode || (e.QrCode = {}));
})(qrcodegen || (qrcodegen = {}));
((e) => {
  ((t) => {
    const n = class {
      /*-- Constructor and fields --*/
      constructor(a, c) {
        this.modeBits = a, this.numBitsCharCount = c;
      }
      /*-- Method --*/
      // (Package-private) Returns the bit width of the character count field for a segment in
      // this mode in a QR Code at the given version number. The result is in the range [0, 16].
      numCharCountBits(a) {
        return this.numBitsCharCount[Math.floor((a + 7) / 17)];
      }
    };
    n.NUMERIC = new n(1, [10, 12, 14]), n.ALPHANUMERIC = new n(2, [9, 11, 13]), n.BYTE = new n(4, [8, 16, 16]), n.KANJI = new n(8, [8, 10, 12]), n.ECI = new n(7, [0, 0, 0]), t.Mode = n;
  })(e.QrSegment || (e.QrSegment = {}));
})(qrcodegen || (qrcodegen = {}));
function generateQRData(e) {
  var a, c, d, u, i, o, s;
  const t = (a = e.amount) == null ? void 0 : a.toFixed(2), n = getReferenceType(e.reference);
  return [
    "SPC",
    // Swiss Payments Code
    "0200",
    // Version
    "1",
    // Coding Type UTF-8
    (c = e.creditor.account) != null ? c : "",
    // IBAN
    ...e.creditor.buildingNumber ? [
      "S",
      // Address Type
      e.creditor.name,
      // Name
      e.creditor.address,
      // Address
      `${e.creditor.buildingNumber}`,
      // Building number
      `${e.creditor.zip}`,
      // Zip
      e.creditor.city
      // City
    ] : [
      "K",
      // Address Type
      e.creditor.name,
      // Name
      e.creditor.address,
      // Address
      `${e.creditor.zip} ${e.creditor.city}`,
      // Zip and city
      "",
      // Empty zip field
      ""
      // Empty city field
    ],
    e.creditor.country,
    // Country
    "",
    // 1x Empty
    "",
    // 2x Empty
    "",
    // 3x Empty
    "",
    // 4x Empty
    "",
    // 5x Empty
    "",
    // 6x Empty
    "",
    // 7x Empty
    t != null ? t : "",
    // Amount
    e.currency,
    // Currency
    ...e.debtor ? [
      ...e.debtor.buildingNumber ? [
        "S",
        // Address Type
        e.debtor.name,
        // Name
        e.debtor.address,
        // Address
        `${e.debtor.buildingNumber}`,
        // Building number
        `${e.debtor.zip}`,
        // Zip
        e.debtor.city
        // City
      ] : [
        "K",
        // Address Type
        e.debtor.name,
        // Name
        e.debtor.address,
        // Address
        `${e.debtor.zip} ${e.debtor.city}`,
        // Zip and city
        "",
        // Empty zip field
        ""
        // Empty city field
      ],
      (u = (d = e.debtor) == null ? void 0 : d.country) != null ? u : ""
      // Country
    ] : [
      "",
      // Empty address type
      "",
      // Empty name
      "",
      // Empty address
      "",
      // Empty zip and city
      "",
      // Empty zip field
      "",
      // Empty city field
      ""
      // Empty country
    ],
    n,
    // Reference type
    (i = e.reference) != null ? i : "",
    // Reference
    (o = e.message) != null ? o : "",
    // Unstructured message
    "EPD",
    // End of payment data
    (s = e.additionalInformation) != null ? s : "",
    // Additional information
    ...e.av1 ? [
      e.av1
    ] : [],
    ...e.av2 ? [
      e.av2
    ] : []
  ].join(`
`);
}
function renderQRCode(e, t, n, r = 0, a = 0) {
  const c = qrcodegen.QrSegment.makeEci(26), d = qrcodegen.QrSegment.makeSegments(e), u = qrcodegen.QrCode.encodeSegments([c, ...d], qrcodegen.QrCode.Ecc.MEDIUM, 10, 25), i = n / u.size, o = [];
  for (let s = 0; s < u.size; s++) {
    const l = s * i;
    for (let f = 0; f < u.size; f++) {
      const m = f * i;
      u.getModule(s, f) && o.push(
        t === "pdf" ? `${limitNumber(r + l)} ${limitNumber(a + m)} ${limitNumber(i)} ${limitNumber(i)} re` : `M ${l}, ${m} V ${m + i} H ${l + i} V ${m} H ${l} Z `
      );
    }
  }
  return o.join(" ");
}
function limitNumber(e) {
  if (e > -1e21 && e < 1e21)
    return Math.round(e * 1e6) / 1e6;
  throw new RangeError(`unsupported number: ${e}`);
}
const translations = {
  DE: {
    acceptancePoint: "Annahmestelle",
    account: "Konto / Zahlbar an",
    additionalInformation: "Zusätzliche Informationen",
    amount: "Betrag",
    currency: "Währung",
    inFavourOf: "Zugunsten",
    payableBy: "Zahlbar durch",
    payableByName: "Zahlbar durch (Name/Adresse)",
    paymentPart: "Zahlteil",
    receipt: "Empfangsschein",
    reference: "Referenz",
    separate: "Vor der Einzahlung abzutrennen"
  },
  EN: {
    acceptancePoint: "Acceptance point",
    account: "Account / Payable to",
    additionalInformation: "Additional information",
    amount: "Amount",
    currency: "Currency",
    inFavourOf: "In favour of",
    payableBy: "Payable by",
    payableByName: "Payable by (name/address)",
    paymentPart: "Payment part",
    receipt: "Receipt",
    reference: "Reference",
    separate: "Separate before paying in"
  },
  FR: {
    acceptancePoint: "Point de dépôt",
    account: "Compte / Payable à",
    additionalInformation: "Informations supplémentaires",
    amount: "Montant",
    currency: "Monnaie",
    inFavourOf: "En faveur de",
    payableBy: "Payable par",
    payableByName: "Payable par (nom/adresse)",
    paymentPart: "Section paiement",
    receipt: "Récépissé",
    reference: "Référence",
    separate: "A détacher avant le versement"
  },
  IT: {
    acceptancePoint: "Punto di accettazione",
    account: "Conto / Pagabile a",
    additionalInformation: "Informazioni supplementari",
    amount: "Importo",
    currency: "Valuta",
    inFavourOf: "A favore di",
    payableBy: "Pagabile da",
    payableByName: "Pagabile da (nome/indirizzo)",
    paymentPart: "Sezione pagamento",
    receipt: "Ricevuta",
    reference: "Riferimento",
    separate: "Da staccare prima del versamento"
  }
};
class ValidationError extends Error {
  constructor(t, n) {
    const r = n ? resolveMessageParams(t, n) : t;
    super(r), this.name = "ValidationError";
  }
}
function resolveMessageParams(e, t) {
  return Object.entries(t).reduce((n, [r, a]) => n.replace(`{${r}}`, a), e);
}
var ValidationErrors = /* @__PURE__ */ ((e) => (e.ACCOUNT_IS_QR_IBAN_BUT_REFERENCE_IS_MISSING = "If there is no reference, a conventional IBAN must be used.", e.ACCOUNT_IS_QR_IBAN_BUT_REFERENCE_IS_REGULAR = "QR-IBAN requires the use of a QR-Reference.", e.ACCOUNT_IS_REGULAR_IBAN_BUT_REFERENCE_IS_QR = "QR-Reference requires the use of a QR-IBAN.", e.ACCOUNT_LENGTH_IS_INVALID = "The provided IBAN number '{iban}' is either too long or too short.", e.ADDITIONAL_INFORMATION_LENGTH_IS_INVALID = "Additional information must be a maximum of 140 characters.", e.ADDITIONAL_INFORMATION_TYPE_IS_INVALID = "Additional information must be a string.", e.ALTERNATIVE_SCHEME_LENGTH_IS_INVALID = "{scheme} must be a maximum of 100 characters.", e.ALTERNATIVE_SCHEME_TYPE_IS_INVALID = "{scheme} must be a string.", e.AMOUNT_LENGTH_IS_INVALID = "Amount must be a maximum of 12 digits.", e.AMOUNT_TYPE_IS_INVALID = "Amount must be a number.", e.CREDITOR_ACCOUNT_COUNTRY_IS_INVALID = "Only CH and LI IBAN numbers are allowed.", e.CREDITOR_ACCOUNT_IS_INVALID = "The provided IBAN number '{iban}' is not valid.", e.CREDITOR_ACCOUNT_IS_UNDEFINED = "Creditor account cannot be undefined.", e.CREDITOR_ADDRESS_IS_UNDEFINED = "Creditor address cannot be undefined.", e.CREDITOR_ADDRESS_LENGTH_IS_INVALID = "Creditor address must be a maximum of 70 characters.", e.CREDITOR_ADDRESS_TYPE_IS_INVALID = "Creditor address TYPE must be a string.", e.CREDITOR_BUILDING_NUMBER_LENGTH_IS_INVALID = "Creditor buildingNumber must be a maximum of 16 characters.", e.CREDITOR_BUILDING_NUMBER_TYPE_IS_INVALID = "Creditor buildingNumber must be either a string or a number.", e.CREDITOR_CITY_IS_UNDEFINED = "Creditor city cannot be undefined.", e.CREDITOR_CITY_LENGTH_IS_INVALID = "Creditor city must be a maximum of 35 characters.", e.CREDITOR_CITY_TYPE_IS_INVALID = "Creditor city must be a string.", e.CREDITOR_COUNTRY_IS_UNDEFINED = "Creditor country cannot be undefined.", e.CREDITOR_COUNTRY_LENGTH_IS_INVALID = "Creditor country must be 2 characters.", e.CREDITOR_COUNTRY_TYPE_IS_INVALID = "Creditor country must be a string.", e.CREDITOR_IS_UNDEFINED = "Creditor cannot be undefined.", e.CREDITOR_NAME_IS_UNDEFINED = "Creditor name cannot be undefined.", e.CREDITOR_NAME_LENGTH_IS_INVALID = "Creditor name must be a maximum of 70 characters.", e.CREDITOR_NAME_TYPE_IS_INVALID = "Creditor name must be a string.", e.CREDITOR_ZIP_IS_UNDEFINED = "Creditor zip cannot be undefined.", e.CREDITOR_ZIP_LENGTH_IS_INVALID = "Creditor zip must be a maximum of 16 characters.", e.CREDITOR_ZIP_TYPE_IS_INVALID = "Creditor zip must be either a string or a number.", e.CURRENCY_IS_UNDEFINED = "Currency cannot be undefined.", e.CURRENCY_LENGTH_IS_INVALID = "Currency must be a length of 3 characters.", e.CURRENCY_STRING_IS_INVALID = "Currency must be either 'CHF' or 'EUR'", e.CURRENCY_TYPE_IS_INVALID = "Currency must be a string.", e.DEBTOR_ADDRESS_IS_UNDEFINED = "Debtor address cannot be undefined.", e.DEBTOR_ADDRESS_LENGTH_IS_INVALID = "Debtor address must be a maximum of 70 characters.", e.DEBTOR_ADDRESS_TYPE_IS_INVALID = "Debtor address TYPE must be a string.", e.DEBTOR_BUILDING_NUMBER_LENGTH_IS_INVALID = "Debtor buildingNumber must be a maximum of 16 characters.", e.DEBTOR_BUILDING_NUMBER_TYPE_IS_INVALID = "Debtor buildingNumber must be either a string or a number.", e.DEBTOR_CITY_IS_UNDEFINED = "Debtor city cannot be undefined.", e.DEBTOR_CITY_LENGTH_IS_INVALID = "Debtor city must be a maximum of 35 characters.", e.DEBTOR_CITY_TYPE_IS_INVALID = "Debtor city must be a string.", e.DEBTOR_COUNTRY_IS_UNDEFINED = "Debtor country cannot be undefined.", e.DEBTOR_COUNTRY_LENGTH_IS_INVALID = "Debtor country must be 2 characters.", e.DEBTOR_COUNTRY_TYPE_IS_INVALID = "Debtor country must be a string.", e.DEBTOR_IS_UNDEFINED = "Debtor cannot be undefined.", e.DEBTOR_NAME_IS_UNDEFINED = "Debtor name cannot be undefined.", e.DEBTOR_NAME_LENGTH_IS_INVALID = "Debtor name must be a maximum of 70 characters.", e.DEBTOR_NAME_TYPE_IS_INVALID = "Debtor name must be a string.", e.DEBTOR_ZIP_IS_UNDEFINED = "Debtor zip cannot be undefined.", e.DEBTOR_ZIP_LENGTH_IS_INVALID = "Debtor zip must be a maximum of 16 characters.", e.DEBTOR_ZIP_TYPE_IS_INVALID = "Debtor zip must be either a string or a number.", e.MESSAGE_AND_ADDITIONAL_INFORMATION_LENGTH_IS_INVALID = "Message and additionalInformation combined must be a maximum of 140 characters.", e.MESSAGE_LENGTH_IS_INVALID = "Message must be a maximum of 140 characters.", e.MESSAGE_TYPE_IS_INVALID = "Message must be a string.", e.QR_REFERENCE_IS_INVALID = "The provided QR-Reference '{reference}' is not valid.", e.QR_REFERENCE_LENGTH_IS_INVALID = "QR-Reference must be a must be exactly 27 characters.", e.REFERENCE_TYPE_IS_INVALID = "Reference must be a string.", e.REGULAR_REFERENCE_LENGTH_IS_INVALID = "Creditor reference must be a maximum of 25 characters.", e))(ValidationErrors || {});
function validateData(e) {
  if (e.reference !== void 0 && typeof e.reference != "string")
    throw new ValidationError(ValidationErrors.REFERENCE_TYPE_IS_INVALID);
  if (e.message !== void 0) {
    if (typeof e.message != "string")
      throw new ValidationError(ValidationErrors.MESSAGE_TYPE_IS_INVALID);
    if (e.message.length > 140)
      throw new ValidationError(ValidationErrors.MESSAGE_LENGTH_IS_INVALID);
  }
  if (e.additionalInformation !== void 0) {
    if (typeof e.additionalInformation != "string")
      throw new ValidationError(ValidationErrors.ADDITIONAL_INFORMATION_TYPE_IS_INVALID);
    if (e.additionalInformation.length > 140)
      throw new ValidationError(ValidationErrors.ADDITIONAL_INFORMATION_LENGTH_IS_INVALID);
  }
  if (e.message !== void 0 && e.additionalInformation !== void 0 && e.additionalInformation.length + e.message.length > 140)
    throw new ValidationError(ValidationErrors.MESSAGE_AND_ADDITIONAL_INFORMATION_LENGTH_IS_INVALID);
  if (e.av1 !== void 0) {
    if (typeof e.av1 != "string")
      throw new ValidationError(ValidationErrors.ALTERNATIVE_SCHEME_TYPE_IS_INVALID, { scheme: "AV1" });
    if (e.av1.length > 100)
      throw new ValidationError(ValidationErrors.ALTERNATIVE_SCHEME_LENGTH_IS_INVALID, { scheme: "AV1" });
  }
  if (e.av2 !== void 0) {
    if (typeof e.av2 != "string")
      throw new ValidationError(ValidationErrors.ALTERNATIVE_SCHEME_TYPE_IS_INVALID, { scheme: "AV2" });
    if (e.av2.length > 100)
      throw new ValidationError(ValidationErrors.ALTERNATIVE_SCHEME_LENGTH_IS_INVALID, { scheme: "AV2" });
  }
  if (e.creditor === void 0)
    throw new ValidationError(ValidationErrors.CREDITOR_IS_UNDEFINED);
  if (e.creditor.account === void 0)
    throw new ValidationError(ValidationErrors.CREDITOR_ACCOUNT_IS_UNDEFINED);
  if (!e.creditor.account.startsWith("CH") && !e.creditor.account.startsWith("LI"))
    throw new ValidationError(ValidationErrors.CREDITOR_ACCOUNT_COUNTRY_IS_INVALID);
  if (e.creditor.account.length !== 21)
    throw new ValidationError(ValidationErrors.ACCOUNT_LENGTH_IS_INVALID, { iban: e.creditor.account });
  if (e.creditor.name === void 0)
    throw new ValidationError(ValidationErrors.CREDITOR_NAME_IS_UNDEFINED);
  if (typeof e.creditor.name != "string")
    throw new ValidationError(ValidationErrors.CREDITOR_NAME_TYPE_IS_INVALID);
  if (e.creditor.name.length > 70)
    throw new ValidationError(ValidationErrors.CREDITOR_NAME_LENGTH_IS_INVALID);
  if (e.creditor.address === void 0)
    throw new ValidationError(ValidationErrors.CREDITOR_ADDRESS_IS_UNDEFINED);
  if (typeof e.creditor.address != "string")
    throw new ValidationError(ValidationErrors.CREDITOR_ADDRESS_TYPE_IS_INVALID);
  if (e.creditor.address.length > 70)
    throw new ValidationError(ValidationErrors.CREDITOR_ADDRESS_LENGTH_IS_INVALID);
  if (e.creditor.buildingNumber !== void 0) {
    if (typeof e.creditor.buildingNumber != "string" && typeof e.creditor.buildingNumber != "number")
      throw new ValidationError(ValidationErrors.CREDITOR_BUILDING_NUMBER_TYPE_IS_INVALID);
    if (e.creditor.buildingNumber.toString().length > 16)
      throw new ValidationError(ValidationErrors.CREDITOR_BUILDING_NUMBER_LENGTH_IS_INVALID);
  }
  if (e.creditor.zip === void 0)
    throw new ValidationError(ValidationErrors.CREDITOR_ZIP_IS_UNDEFINED);
  if (typeof e.creditor.zip != "string" && typeof e.creditor.zip != "number")
    throw new ValidationError(ValidationErrors.CREDITOR_ZIP_TYPE_IS_INVALID);
  if (e.creditor.zip.toString().length > 16)
    throw new ValidationError(ValidationErrors.CREDITOR_ZIP_LENGTH_IS_INVALID);
  if (e.creditor.city === void 0)
    throw new ValidationError(ValidationErrors.CREDITOR_CITY_IS_UNDEFINED);
  if (typeof e.creditor.city != "string")
    throw new ValidationError(ValidationErrors.CREDITOR_CITY_TYPE_IS_INVALID);
  if (e.creditor.city.length > 35)
    throw new ValidationError(ValidationErrors.CREDITOR_CITY_LENGTH_IS_INVALID);
  if (e.creditor.country === void 0)
    throw new ValidationError(ValidationErrors.CREDITOR_COUNTRY_IS_UNDEFINED);
  if (typeof e.creditor.country != "string")
    throw new ValidationError(ValidationErrors.CREDITOR_COUNTRY_TYPE_IS_INVALID);
  if (e.creditor.country.length !== 2)
    throw new ValidationError(ValidationErrors.CREDITOR_COUNTRY_LENGTH_IS_INVALID);
  if (e.amount !== void 0) {
    if (typeof e.amount != "number")
      throw new ValidationError(ValidationErrors.AMOUNT_TYPE_IS_INVALID);
    if (e.amount.toFixed(2).toString().length > 12)
      throw new ValidationError(ValidationErrors.AMOUNT_LENGTH_IS_INVALID);
  }
  if (e.currency === void 0)
    throw new ValidationError(ValidationErrors.CURRENCY_IS_UNDEFINED);
  if (typeof e.currency != "string")
    throw new ValidationError(ValidationErrors.CURRENCY_TYPE_IS_INVALID);
  if (e.currency.length !== 3)
    throw new ValidationError(ValidationErrors.CURRENCY_LENGTH_IS_INVALID);
  if (e.currency !== "CHF" && e.currency !== "EUR")
    throw new ValidationError(ValidationErrors.CURRENCY_STRING_IS_INVALID);
  if (e.debtor !== void 0) {
    if (e.debtor.name === void 0)
      throw new ValidationError(ValidationErrors.DEBTOR_NAME_IS_UNDEFINED);
    if (typeof e.debtor.name != "string")
      throw new ValidationError(ValidationErrors.DEBTOR_NAME_TYPE_IS_INVALID);
    if (e.debtor.name.length > 70)
      throw new ValidationError(ValidationErrors.DEBTOR_NAME_LENGTH_IS_INVALID);
    if (e.debtor.address === void 0)
      throw new ValidationError(ValidationErrors.DEBTOR_ADDRESS_IS_UNDEFINED);
    if (typeof e.debtor.address != "string")
      throw new ValidationError(ValidationErrors.DEBTOR_ADDRESS_TYPE_IS_INVALID);
    if (e.debtor.address.length > 70)
      throw new ValidationError(ValidationErrors.DEBTOR_ADDRESS_LENGTH_IS_INVALID);
    if (e.debtor.buildingNumber !== void 0) {
      if (typeof e.debtor.buildingNumber != "string" && typeof e.debtor.buildingNumber != "number")
        throw new ValidationError(ValidationErrors.DEBTOR_BUILDING_NUMBER_TYPE_IS_INVALID);
      if (e.debtor.buildingNumber.toString().length > 16)
        throw new ValidationError(ValidationErrors.DEBTOR_BUILDING_NUMBER_LENGTH_IS_INVALID);
    }
    if (e.debtor.zip === void 0)
      throw new ValidationError(ValidationErrors.DEBTOR_ZIP_IS_UNDEFINED);
    if (typeof e.debtor.zip != "string" && typeof e.debtor.zip != "number")
      throw new ValidationError(ValidationErrors.DEBTOR_ZIP_TYPE_IS_INVALID);
    if (e.debtor.zip.toString().length > 16)
      throw new ValidationError(ValidationErrors.DEBTOR_ZIP_LENGTH_IS_INVALID);
    if (e.debtor.city === void 0)
      throw new ValidationError(ValidationErrors.DEBTOR_CITY_IS_UNDEFINED);
    if (typeof e.debtor.city != "string")
      throw new ValidationError(ValidationErrors.DEBTOR_CITY_TYPE_IS_INVALID);
    if (e.debtor.city.length > 35)
      throw new ValidationError(ValidationErrors.DEBTOR_CITY_LENGTH_IS_INVALID);
    if (e.debtor.country === void 0)
      throw new ValidationError(ValidationErrors.DEBTOR_COUNTRY_IS_UNDEFINED);
    if (typeof e.debtor.country != "string")
      throw new ValidationError(ValidationErrors.DEBTOR_COUNTRY_TYPE_IS_INVALID);
    if (e.debtor.country.length !== 2)
      throw new ValidationError(ValidationErrors.DEBTOR_COUNTRY_LENGTH_IS_INVALID);
  }
  if (isIBANValid(e.creditor.account) === !1)
    throw new ValidationError(ValidationErrors.CREDITOR_ACCOUNT_IS_INVALID, { iban: e.creditor.account });
  if (isQRIBAN(e.creditor.account)) {
    if (e.reference === void 0)
      throw new ValidationError(ValidationErrors.ACCOUNT_IS_QR_IBAN_BUT_REFERENCE_IS_MISSING);
    if (e.reference.length !== 27)
      throw new ValidationError(ValidationErrors.QR_REFERENCE_LENGTH_IS_INVALID);
    if (isQRReference(e.reference)) {
      if (!isQRReferenceValid(e.reference))
        throw new ValidationError(ValidationErrors.QR_REFERENCE_IS_INVALID, { reference: e.reference });
    } else
      throw new ValidationError(ValidationErrors.ACCOUNT_IS_QR_IBAN_BUT_REFERENCE_IS_REGULAR);
  } else if (e.reference !== void 0) {
    if (isQRReference(e.reference))
      throw new ValidationError(ValidationErrors.ACCOUNT_IS_REGULAR_IBAN_BUT_REFERENCE_IS_QR);
    if (e.reference.length > 25)
      throw new ValidationError(ValidationErrors.REGULAR_REFERENCE_LENGTH_IS_INVALID);
  }
}
const arial8pt = {
  100: 6.11767578125,
  101: 6.11767578125,
  102: 3.05615234375,
  103: 6.11767578125,
  104: 6.11767578125,
  105: 2.44384765625,
  106: 2.44384765625,
  107: 5.5,
  108: 2.44384765625,
  109: 9.1630859375,
  110: 6.11767578125,
  111: 6.11767578125,
  112: 6.11767578125,
  113: 6.11767578125,
  114: 3.6630859375,
  115: 5.5,
  116: 3.05615234375,
  117: 6.11767578125,
  118: 5.5,
  119: 7.94384765625,
  120: 5.5,
  121: 5.5,
  122: 5.5,
  123: 3.673828125,
  124: 2.857421875,
  125: 3.673828125,
  126: 6.423828125,
  160: 3.05615234375,
  161: 3.6630859375,
  162: 6.11767578125,
  163: 6.11767578125,
  164: 6.11767578125,
  165: 6.11767578125,
  166: 2.857421875,
  167: 6.11767578125,
  168: 3.6630859375,
  169: 8.10498046875,
  170: 4.0712890625,
  171: 6.11767578125,
  172: 6.423828125,
  173: 0,
  174: 8.10498046875,
  175: 6.07470703125,
  176: 4.39892578125,
  177: 6.037109375,
  178: 3.6630859375,
  179: 3.6630859375,
  180: 3.6630859375,
  181: 6.337890625,
  182: 5.908203125,
  183: 3.6630859375,
  184: 3.6630859375,
  185: 3.6630859375,
  186: 4.017578125,
  187: 6.11767578125,
  188: 9.173828125,
  189: 9.173828125,
  190: 9.173828125,
  191: 6.71923828125,
  192: 7.3369140625,
  193: 7.3369140625,
  194: 7.3369140625,
  195: 7.3369140625,
  196: 7.3369140625,
  197: 7.3369140625,
  198: 11,
  199: 7.94384765625,
  200: 7.3369140625,
  201: 7.3369140625,
  202: 7.3369140625,
  203: 7.3369140625,
  204: 3.05615234375,
  205: 3.05615234375,
  206: 3.05615234375,
  207: 3.05615234375,
  208: 7.94384765625,
  209: 7.94384765625,
  210: 8.55615234375,
  211: 8.55615234375,
  212: 8.55615234375,
  213: 8.55615234375,
  214: 8.55615234375,
  215: 6.423828125,
  216: 8.55615234375,
  217: 7.94384765625,
  218: 7.94384765625,
  219: 7.94384765625,
  220: 7.94384765625,
  221: 7.3369140625,
  222: 7.3369140625,
  223: 6.71923828125,
  224: 6.11767578125,
  225: 6.11767578125,
  226: 6.11767578125,
  227: 6.11767578125,
  228: 6.11767578125,
  229: 6.11767578125,
  230: 9.78076171875,
  231: 5.5,
  232: 6.11767578125,
  233: 6.11767578125,
  234: 6.11767578125,
  235: 6.11767578125,
  236: 3.05615234375,
  237: 3.05615234375,
  238: 3.05615234375,
  239: 3.05615234375,
  240: 6.11767578125,
  241: 6.11767578125,
  242: 6.11767578125,
  243: 6.11767578125,
  244: 6.11767578125,
  245: 6.11767578125,
  246: 6.11767578125,
  247: 6.037109375,
  248: 6.71923828125,
  249: 6.11767578125,
  250: 6.11767578125,
  251: 6.11767578125,
  252: 6.11767578125,
  253: 5.5,
  254: 6.11767578125,
  32: 3.05615234375,
  33: 3.05615234375,
  34: 3.90478515625,
  35: 6.11767578125,
  36: 6.11767578125,
  37: 9.78076171875,
  38: 7.3369140625,
  39: 2.10009765625,
  40: 3.6630859375,
  41: 3.6630859375,
  42: 4.28076171875,
  43: 6.423828125,
  44: 3.05615234375,
  45: 3.6630859375,
  46: 3.05615234375,
  47: 3.05615234375,
  48: 6.11767578125,
  49: 6.11767578125,
  50: 6.11767578125,
  51: 6.11767578125,
  52: 6.11767578125,
  53: 6.11767578125,
  54: 6.11767578125,
  55: 6.11767578125,
  56: 6.11767578125,
  57: 6.11767578125,
  58: 3.05615234375,
  59: 3.05615234375,
  60: 6.423828125,
  61: 6.423828125,
  62: 6.423828125,
  63: 6.11767578125,
  64: 11.16650390625,
  65: 7.3369140625,
  66: 7.3369140625,
  67: 7.94384765625,
  68: 7.94384765625,
  69: 7.3369140625,
  70: 6.71923828125,
  71: 8.55615234375,
  72: 7.94384765625,
  73: 3.05615234375,
  74: 5.5,
  75: 7.3369140625,
  76: 6.11767578125,
  77: 9.1630859375,
  78: 7.94384765625,
  79: 8.55615234375,
  80: 7.3369140625,
  81: 8.55615234375,
  82: 7.94384765625,
  83: 7.3369140625,
  84: 6.71923828125,
  85: 7.94384765625,
  86: 7.3369140625,
  87: 10.38232421875,
  88: 7.3369140625,
  89: 7.3369140625,
  90: 6.71923828125,
  91: 3.05615234375,
  92: 3.05615234375,
  93: 3.05615234375,
  94: 5.16162109375,
  95: 6.11767578125,
  96: 3.6630859375,
  97: 6.11767578125,
  98: 6.11767578125,
  99: 5.5
}, arial10pt = {
  100: 7.22998046875,
  101: 7.22998046875,
  102: 3.61181640625,
  103: 7.22998046875,
  104: 7.22998046875,
  105: 2.88818359375,
  106: 2.88818359375,
  107: 6.5,
  108: 2.88818359375,
  109: 10.8291015625,
  110: 7.22998046875,
  111: 7.22998046875,
  112: 7.22998046875,
  113: 7.22998046875,
  114: 4.3291015625,
  115: 6.5,
  116: 3.61181640625,
  117: 7.22998046875,
  118: 6.5,
  119: 9.38818359375,
  120: 6.5,
  121: 6.5,
  122: 6.5,
  123: 4.341796875,
  124: 3.376953125,
  125: 4.341796875,
  126: 7.591796875,
  160: 3.61181640625,
  161: 4.3291015625,
  162: 7.22998046875,
  163: 7.22998046875,
  164: 7.22998046875,
  165: 7.22998046875,
  166: 3.376953125,
  167: 7.22998046875,
  168: 4.3291015625,
  169: 9.57861328125,
  170: 4.8115234375,
  171: 7.22998046875,
  172: 7.591796875,
  173: 0,
  174: 9.57861328125,
  175: 7.17919921875,
  176: 5.19873046875,
  177: 7.134765625,
  178: 4.3291015625,
  179: 4.3291015625,
  180: 4.3291015625,
  181: 7.490234375,
  182: 6.982421875,
  183: 4.3291015625,
  184: 4.3291015625,
  185: 4.3291015625,
  186: 4.748046875,
  187: 7.22998046875,
  188: 10.841796875,
  189: 10.841796875,
  190: 10.841796875,
  191: 7.94091796875,
  192: 8.6708984375,
  193: 8.6708984375,
  194: 8.6708984375,
  195: 8.6708984375,
  196: 8.6708984375,
  197: 8.6708984375,
  198: 13,
  199: 9.38818359375,
  200: 8.6708984375,
  201: 8.6708984375,
  202: 8.6708984375,
  203: 8.6708984375,
  204: 3.61181640625,
  205: 3.61181640625,
  206: 3.61181640625,
  207: 3.61181640625,
  208: 9.38818359375,
  209: 9.38818359375,
  210: 10.11181640625,
  211: 10.11181640625,
  212: 10.11181640625,
  213: 10.11181640625,
  214: 10.11181640625,
  215: 7.591796875,
  216: 10.11181640625,
  217: 9.38818359375,
  218: 9.38818359375,
  219: 9.38818359375,
  220: 9.38818359375,
  221: 8.6708984375,
  222: 8.6708984375,
  223: 7.94091796875,
  224: 7.22998046875,
  225: 7.22998046875,
  226: 7.22998046875,
  227: 7.22998046875,
  228: 7.22998046875,
  229: 7.22998046875,
  230: 11.55908203125,
  231: 6.5,
  232: 7.22998046875,
  233: 7.22998046875,
  234: 7.22998046875,
  235: 7.22998046875,
  236: 3.61181640625,
  237: 3.61181640625,
  238: 3.61181640625,
  239: 3.61181640625,
  240: 7.22998046875,
  241: 7.22998046875,
  242: 7.22998046875,
  243: 7.22998046875,
  244: 7.22998046875,
  245: 7.22998046875,
  246: 7.22998046875,
  247: 7.134765625,
  248: 7.94091796875,
  249: 7.22998046875,
  250: 7.22998046875,
  251: 7.22998046875,
  252: 7.22998046875,
  253: 6.5,
  254: 7.22998046875,
  32: 3.61181640625,
  33: 3.61181640625,
  34: 4.61474609375,
  35: 7.22998046875,
  36: 7.22998046875,
  37: 11.55908203125,
  38: 8.6708984375,
  39: 2.48193359375,
  40: 4.3291015625,
  41: 4.3291015625,
  42: 5.05908203125,
  43: 7.591796875,
  44: 3.61181640625,
  45: 4.3291015625,
  46: 3.61181640625,
  47: 3.61181640625,
  48: 7.22998046875,
  49: 7.22998046875,
  50: 7.22998046875,
  51: 7.22998046875,
  52: 7.22998046875,
  53: 7.22998046875,
  54: 7.22998046875,
  55: 7.22998046875,
  56: 7.22998046875,
  57: 7.22998046875,
  58: 3.61181640625,
  59: 3.61181640625,
  60: 7.591796875,
  61: 7.591796875,
  62: 7.591796875,
  63: 7.22998046875,
  64: 13.19677734375,
  65: 8.6708984375,
  66: 8.6708984375,
  67: 9.38818359375,
  68: 9.38818359375,
  69: 8.6708984375,
  70: 7.94091796875,
  71: 10.11181640625,
  72: 9.38818359375,
  73: 3.61181640625,
  74: 6.5,
  75: 8.6708984375,
  76: 7.22998046875,
  77: 10.8291015625,
  78: 9.38818359375,
  79: 10.11181640625,
  80: 8.6708984375,
  81: 10.11181640625,
  82: 9.38818359375,
  83: 8.6708984375,
  84: 7.94091796875,
  85: 9.38818359375,
  86: 8.6708984375,
  87: 12.27001953125,
  88: 8.6708984375,
  89: 8.6708984375,
  90: 7.94091796875,
  91: 3.61181640625,
  92: 3.61181640625,
  93: 3.61181640625,
  94: 6.10009765625,
  95: 7.22998046875,
  96: 4.3291015625,
  97: 7.22998046875,
  98: 7.22998046875,
  99: 6.5
};
function calculateTextWidth(e, t) {
  let n = 0;
  if (t === "8pt")
    for (let r = 0; r < e.length; r++)
      n += arial8pt[e.charCodeAt(r)];
  else if (t === "10pt")
    for (let r = 0; r < e.length; r++)
      n += arial10pt[e.charCodeAt(r)];
  return n;
}
class SwissQRBill {
  constructor(t, n) {
    this._language = "DE", this._data = t, this._data = cleanData(this._data), validateData(this._data), n !== void 0 && n.language !== void 0 && (this._language = n.language), this.instance = new SVG(), this.instance.width("210mm"), this.instance.height("105mm"), this._render();
  }
  get outerHTML() {
    return this.instance.outerHTML;
  }
  /**
   * Outputs the SVG as a string.
   * @returns The outerHTML of the SVG as a `string`.
   */
  toString() {
    return this.outerHTML;
  }
  /**
   * Returns the SVG element.
   * @readonly
   * @returns The SVG element.
   */
  // public get element(): SVGElement {
  //   return this.instance.element as unknown as SVGElement;
  // }
  _render() {
    const t = this._formatAddress(this._data.creditor);
    let n = 0, r = 0;
    this.instance.addRect(0, 0, "100%", "100%").fill("#fff"), this.instance.addLine("62mm", "0mm", "62mm", "105mm").stroke(1, "dashed", "black");
    const a = "M8.55299 18.3969C9.54465 17.5748 9.51074 16.0915 9.08357 14.9829L6.47473 8.02261C7.58167 5.9986 7.26467 3.99833 7.80373 3.99833C8.22582 3.99833 8.13259 4.38482 9.23105 4.32719C10.2854 4.27125 11.0652 3.1711 10.9957 2.13197C11.0025 1.09115 10.2041 0.0130391 9.1056 0.00456339C7.99867 -0.0734135 6.96972 0.858918 6.89683 1.95907C6.70527 3.24907 7.48674 5.53413 5.56613 6.60547C4.09305 5.80705 4.08797 4.38991 4.16255 3.10838C4.22358 2.04552 3.91845 0.76738 2.87424 0.260531C1.87241 -0.229367 0.446794 0.25036 0.139972 1.37594C-0.277034 2.51168 0.250156 4.07122 1.55541 4.34244C2.56233 4.55095 3.03528 3.83729 3.40143 4.1119C3.67774 4.31871 3.5167 5.62906 4.566 7.96667L1.908 15.5033C1.64356 16.456 1.65204 17.6206 2.58776 18.463L5.5424 10.6484L8.55299 18.3969ZM10.1634 2.87953C9.55143 3.97629 7.88849 3.88645 7.56641 2.74731C7.20704 1.71666 8.20887 0.397838 9.32767 0.726697C10.2447 0.919943 10.5821 2.12858 10.1634 2.87953ZM3.36753 2.927C2.94544 4.07122 1.00789 3.87797 0.746835 2.71341C0.479001 1.94042 0.8638 0.836881 1.77409 0.758904C2.88102 0.608036 3.87946 1.90821 3.36753 2.927Z";
    this.instance.addSVG("11px", "19px").x(calc("62mm - 5.25px")).y("30pt").addPath(a).fill("black");
    const d = this.instance.addSVG().x("5mm").y("5mm"), u = d.addText();
    u.addTSpan(translations[this._language].receipt).x(0).y(0).dy("11pt").fontFamily("Arial").fontWeight("bold").fontSize("11pt"), u.addTSpan(translations[this._language].account).x(0).y("7mm").dy("9pt").fontFamily("Arial").fontWeight("bold").fontSize("6pt"), u.addTSpan(formatIBAN(this._data.creditor.account)).x(0).dy("9pt").fontFamily("Arial").fontWeight("normal").fontSize("8pt"), n++;
    let i = [];
    for (const g of t) {
      const y = this._fitTextToWidth(g, mm2px(52), 2, "8pt");
      i = [...i, ...y];
    }
    for (const g of i)
      n++, u.addTSpan(g).x(0).dy("9pt").fontFamily("Arial").fontWeight("normal").fontSize("8pt");
    if (this._data.reference !== void 0 && (u.addTSpan(translations[this._language].reference).x(0).dy("18pt").fontFamily("Arial").fontWeight("bold").fontSize("6pt"), u.addTSpan(formatReference(this._data.reference)).x(0).dy("9pt").fontFamily("Arial").fontWeight("normal").fontSize("8pt"), n++), this._data.debtor !== void 0) {
      const g = this._formatAddress(this._data.debtor);
      u.addTSpan(translations[this._language].payableBy).x(0).dy("18pt").fontFamily("Arial").fontWeight("bold").fontSize("6pt");
      let y = [];
      for (const p of g) {
        const N = this._fitTextToWidth(p, mm2px(52), 2, "8pt");
        y = [...y, ...N];
      }
      for (const p of y)
        u.addTSpan(p).x(0).dy("9pt").fontFamily("Arial").fontWeight("normal").fontSize("8pt");
    } else {
      u.addTSpan(translations[this._language].payableByName).x(0).dy("18pt").fontFamily("Arial").fontWeight("bold").fontSize("6pt");
      const g = this._data.reference !== void 0 ? "18pt" : "0";
      this._addRectangle(5, calc(`12mm + 9pt + (${n} * 9pt) + ${g} + 18pt + 1mm`, "mm"), 52, 20);
    }
    const o = d.addText().y("63mm");
    o.addTSpan(translations[this._language].currency).x(0).dy("6pt").fontFamily("Arial").fontWeight("bold").fontSize("6pt");
    const s = this._data.amount === void 0 ? 13 : 22;
    o.addTSpan(translations[this._language].amount).x(`${s}mm`).fontFamily("Arial").fontWeight("bold").fontSize("6pt"), o.addTSpan(this._data.currency).x(0).dy("11pt").fontFamily("Arial").fontWeight("normal").fontSize("8pt"), this._data.amount !== void 0 ? o.addTSpan(formatAmount(this._data.amount)).x(`${s}mm`).fontFamily("Arial").fontWeight("normal").fontSize("8pt") : this._addRectangle(27, 68, 30, 10), o.addTSpan(translations[this._language].acceptancePoint).x("52mm").y("82mm").textAlign("right").fontFamily("Arial").fontWeight("bold").fontSize("6pt");
    const l = this.instance.addSVG().x("67mm").y("5mm");
    l.addText(translations[this._language].paymentPart).x(0).y(0).dy("11pt").fontFamily("Arial").fontWeight("bold").fontSize("11pt"), this._renderQRCode();
    const f = l.addText().y("63mm");
    f.addTSpan(translations[this._language].currency).x(0).dy("8pt").fontFamily("Arial").fontWeight("bold").fontSize("8pt"), f.addTSpan(translations[this._language].amount).x("22mm").fontFamily("Arial").fontWeight("bold").fontSize("8pt"), f.addTSpan(this._data.currency).x(0).dy("13pt").fontFamily("Arial").fontWeight("normal").fontSize("10pt"), this._data.amount !== void 0 ? f.addTSpan(formatAmount(this._data.amount)).x("22mm").fontFamily("Arial").fontWeight("normal").fontSize("10pt") : this._addRectangle(78, calc("68mm + 8pt + 5pt", "mm"), 40, 15);
    const m = l.addText().x(0).y("90mm");
    if (this._data.av1 !== void 0) {
      const [g, y] = this._data.av1.split(/(\/.+)/);
      m.addTSpan(g).x(0).fontFamily("Arial").fontWeight("bold").fontSize("7pt"), m.addTSpan(this._data.av1.length > 90 ? `${y.substr(0, 87)}...` : y).fontFamily("Arial").fontWeight("normal").fontSize("7pt");
    }
    if (this._data.av2 !== void 0) {
      const [g, y] = this._data.av2.split(/(\/.+)/);
      m.addTSpan(g).x(0).dy("8pt").fontFamily("Arial").fontWeight("bold").fontSize("7pt"), m.addTSpan(this._data.av2.length > 90 ? `${y.substr(0, 87)}...` : y).fontFamily("Arial").fontWeight("normal").fontSize("7pt");
    }
    const I = this.instance.addSVG().x("118mm").y("5mm").addText();
    I.addTSpan(translations[this._language].account).x(0).y(0).dy("11pt").fontFamily("Arial").fontWeight("bold").fontSize("8pt"), I.addTSpan(formatIBAN(this._data.creditor.account)).x(0).dy("11pt").fontFamily("Arial").fontWeight("normal").fontSize("10pt"), r++;
    let E = [];
    for (const g of t) {
      const y = this._fitTextToWidth(g, mm2px(52), 2, "8pt");
      E = [...E, ...y];
    }
    for (const g of E)
      I.addTSpan(g).x(0).dy("11pt").fontFamily("Arial").fontWeight("normal").fontSize("10pt"), r++;
    if (this._data.reference !== void 0 && (I.addTSpan(translations[this._language].reference).x(0).dy("22pt").fontFamily("Arial").fontWeight("bold").fontSize("8pt"), I.addTSpan(formatReference(this._data.reference)).x(0).dy("11pt").fontFamily("Arial").fontWeight("normal").fontSize("10pt"), r++), this._data.message !== void 0 || this._data.additionalInformation !== void 0) {
      I.addTSpan(translations[this._language].additionalInformation).x(0).dy("22pt").fontFamily("Arial").fontWeight("bold").fontSize("8pt");
      const g = getReferenceType(this._data.reference), y = g === "QRR" || g === "SCOR" ? 3 : 4, p = mm2px(87);
      this._getLineCountOfText(this._data.message, p, "10pt");
      const N = this._getLineCountOfText(this._data.additionalInformation, p, "10pt");
      if (this._data.additionalInformation !== void 0) {
        if (g === "QRR" || g === "SCOR")
          this._data.message !== void 0 && (I.addTSpan(this._ellipsis(this._data.message, p, "10pt")).x(0).dy("11pt").fontFamily("Arial").fontWeight("normal").fontSize("10pt"), r++);
        else if (this._data.message !== void 0) {
          const R = y - N, D = this._fitTextToWidth(this._data.message, p, R, "10pt");
          for (let A = 0; A < R; A++)
            I.addTSpan(D[A]).x(0).dy("11pt").fontFamily("Arial").fontWeight("normal").fontSize("10pt"), r++;
        }
        const T = this._fitTextToWidth(this._data.additionalInformation, p, N, "10pt");
        for (let R = 0; R < N; R++)
          I.addTSpan(T[R]).x(0).dy("11pt").fontFamily("Arial").fontWeight("normal").fontSize("10pt"), r++;
      } else if (this._data.message !== void 0) {
        const T = this._fitTextToWidth(this._data.message, p, y, "10pt");
        for (let R = 0; R < y; R++)
          I.addTSpan(T[R]).x(0).dy("11pt").fontFamily("Arial").fontWeight("normal").fontSize("10pt"), r++;
      }
    }
    if (this._data.debtor !== void 0) {
      const g = this._formatAddress(this._data.debtor);
      I.addTSpan(translations[this._language].payableBy).x(0).dy("22pt").fontFamily("Arial").fontWeight("bold").fontSize("8pt");
      let y = [];
      for (const p of g) {
        const N = this._fitTextToWidth(p, mm2px(52), 2, "8pt");
        y = [...y, ...N];
      }
      for (const p of y)
        I.addTSpan(p).x(0).dy("11pt").fontFamily("Arial").fontWeight("normal").fontSize("10pt");
    } else {
      I.addTSpan(translations[this._language].payableByName).x(0).dy("22pt").fontFamily("Arial").fontWeight("bold").fontSize("8pt");
      const g = this._data.reference !== void 0 ? "22pt" : "0", y = this._data.additionalInformation !== void 0 || this._data.message !== void 0 ? "22pt" : "0";
      this._addRectangle(118, calc(`5mm + 11pt + (${r} * 11pt) + ${g} + ${y} + 22pt + 1mm`, "mm"), 65, 25);
    }
  }
  _renderQRCode() {
    const t = generateQRData(this._data), n = renderQRCode(t, "svg", mm2px(46), 0, 0), r = this.instance.addSVG("46mm", "46mm").y("17mm").x("67mm");
    r.addPath(n).fill("black"), r.addRect("19mm", "19mm", "8mm", "8mm").fill("white"), r.addRect("19.5mm", "19.5mm", "7mm", "7mm").fill("black"), r.addRect("22.415mm", "21.055mm", "1.17mm", "3.89mm").fill("white"), r.addRect("21.055mm", "22.415mm", "3.89mm", "1.17mm").fill("white");
  }
  _formatAddress(t) {
    const n = t.country !== "CH" ? `${t.country} - ` : "";
    return t.buildingNumber !== void 0 ? [t.name, `${t.address} ${t.buildingNumber}`, `${n}${t.zip} ${t.city}`] : [t.name, t.address, `${n}${t.zip} ${t.city}`];
  }
  _getLineCountOfText(t, n, r) {
    if (t === void 0)
      return 0;
    {
      let a = 0, c = calculateTextWidth(t, r);
      for (; c > 1; )
        a++, c -= n;
      return a;
    }
  }
  _fitTextToWidth(t, n, r, a) {
    var o;
    const c = t.split(/([ |-])/g);
    let d = [], u = "";
    const i = (s) => {
      const l = [];
      let f = "";
      if (calculateTextWidth(s, a) > n) {
        const m = s.split("");
        let h = "";
        for (; m.length > 0; )
          calculateTextWidth(h, a) <= n ? h += m.shift() : (l.push(h), h = "");
        h !== "" && (f = h);
      } else
        l.push(s);
      return { leftover: f, lines: l };
    };
    for (; c.length > 0; ) {
      const s = c.shift(), l = (o = c.shift()) != null ? o : "";
      if (calculateTextWidth(u + s + l, a) <= n)
        u += s + l;
      else if (u !== "") {
        const { leftover: f, lines: m } = i(u);
        d.push(...m), u = f + s + l;
      } else
        u = s + l;
    }
    if (u !== "" && u !== " ") {
      const { leftover: s, lines: l } = i(u);
      d.push(...l), s !== "" && d.push(s);
    }
    return d.length > r && (d = d.slice(0, r), d[d.length - 1] = this._ellipsis(d[d.length - 1], n, a)), d;
  }
  _ellipsis(t, n, r) {
    let a = "";
    if (calculateTextWidth(t, r) > n)
      for (let c = 0; c < t.length && calculateTextWidth(`${a}${t[c]}...`, r) <= n; c++)
        a += t[c];
    else
      return t;
    return a.substr(-1) === " " && (a = a.slice(0, -1)), `${a}...`;
  }
  _addRectangle(t, n, r, a) {
    const c = this.instance.addSVG(`${r}mm`, `${a}mm`);
    c.x(`${t}mm`).y(`${n}mm`);
    const d = 3;
    return c.addLine("0mm", "0mm", `${d}mm`, "0mm").stroke(".75pt", "solid", "black"), c.addLine(`${r - d}mm`, "0mm", `${r}mm`, "0mm").stroke(".75pt", "solid", "black"), c.addLine(`${r}mm`, "0mm", `${r}mm`, `${d}mm`).stroke(".75pt", "solid", "black"), c.addLine(`${r}mm`, `${a - d}mm`, `${r}mm`, `${a}mm`).stroke(".75pt", "solid", "black"), c.addLine(`${r - d}mm`, `${a}mm`, `${r}mm`, `${a}mm`).stroke(".75pt", "solid", "black"), c.addLine("0mm", `${a}mm`, `${d}mm`, `${a}mm`).stroke(".75pt", "solid", "black"), c.addLine("0mm", `${a - d}mm`, "0mm", `${a}mm`).stroke(".75pt", "solid", "black"), c.addLine("0mm", "0mm", "0mm", `${d}mm`).stroke(".75pt", "solid", "black"), c;
  }
}
export {
  SwissQRBill
};
